unit MainUnit;

interface

uses
	MasterUnit, SourceFileUnit, ObjectFileUnit, ToolsListUnit,
	Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
	Menus, StdCtrls, ExtCtrls, ImgList, ComCtrls, Buttons, ActnList, ToolWin,
	Printers, SourceEditUnit, HTMLHelpUnit, MemoComponentUnit, ScktComp;

type
	TMainForm = class(TForm)
		ProjectTree: TTreeView;
		LittleIcons: TImageList;
		TreeEditorSplitter: TSplitter;
		MainMenu: TMainMenu;
    MainMenuFile: TMenuItem;
    MenuFileNew: TMenuItem;
		Project1: TMenuItem;
		AssemblerSource1: TMenuItem;
		Open1: TMenuItem;
		Save1: TMenuItem;
		SaveAs1: TMenuItem;
		N1: TMenuItem;
		Exit1: TMenuItem;
		CSourceFile1: TMenuItem;
    MainMenuEdit: TMenuItem;
		Undo1: TMenuItem;
		N2: TMenuItem;
		Delete1: TMenuItem;
		Cut1: TMenuItem;
		Copy1: TMenuItem;
		Paste1: TMenuItem;
		AddFiles1: TMenuItem;
    MenuCompileLine: TMenuItem;
		MainMenuProject: TMenuItem;
		Compile1: TMenuItem;
		Link1: TMenuItem;
		N4: TMenuItem;
		Options1: TMenuItem;
		AddFileDlg: TOpenDialog;
		N5: TMenuItem;
		Preferences1: TMenuItem;
		N6: TMenuItem;
		HeaderFile1: TMenuItem;
		ProjectTreePopup: TPopupMenu;
		Compile2: TMenuItem;
		N7: TMenuItem;
		Remove1: TMenuItem;
		Delete2: TMenuItem;
		Splitter2: TSplitter;
		ErrWinPanel: TPanel;
		ErrorPanel: TPanel;
		CloseErrorsButton: TSpeedButton;
		ErrorList: TListView;
		Label1: TLabel;
		Label2: TLabel;
		ErrorsLabel: TLabel;
		WarningsLabel: TLabel;
		Save2: TMenuItem;
		SaveAs2: TMenuItem;
		N8: TMenuItem;
    MainMenuHelp: TMenuItem;
		Build1: TMenuItem;
		N9: TMenuItem;
		SelectAll1: TMenuItem;
		OpenProjectDlg: TOpenDialog;
		SaveProjectDlg: TSaveDialog;
		N10: TMenuItem;
		About1: TMenuItem;
		StatusBar: TStatusBar;
		ToolBarImages: TImageList;
		FileNewPopup: TPopupMenu;
		HeaderFile2: TMenuItem;
		Actions: TActionList;
		ActionFileNewProject: TAction;
		ActionFileNewHeaderFile: TAction;
		ActionFileNewCFile: TAction;
		ActionFileNewA68kAsmFile: TAction;
		ActionFileOpen: TAction;
		ActionFileSave: TAction;
		ActionFileSaveAs: TAction;
		ActionFilePreferences: TAction;
		ActionFileExit: TAction;
		ActionEditUndo: TAction;
		ActionEditDelete: TAction;
		ActionEditCut: TAction;
		ActionEditCopy: TAction;
		ActionEditPaste: TAction;
		ActionEditSelectAll: TAction;
		ActionProjectAddFiles: TAction;
		ActionProjectCompile: TAction;
		ActionProjectMake: TAction;
		ActionProjectBuild: TAction;
		ActionProjectOptions: TAction;
		ActionHelpDocumentation: TAction;
		ActionHelpAbout: TAction;
		ActionTreeItemSave: TAction;
		ActionTreeItemSaveAs: TAction;
		ActionTreeItemCompile: TAction;
		ActionTreeItemRemove: TAction;
		ActionTreeItemDelete: TAction;
		CSourceFile2: TMenuItem;
		AssemblerSourceFile1: TMenuItem;
		Project3: TMenuItem;
		N11: TMenuItem;
		ActionProjectShowErrors: TAction;
		ErrorsandWarnings1: TMenuItem;
		N12: TMenuItem;
    MainMenuFind: TMenuItem;
		ActionFindFind: TAction;
		ActionFindReplace: TAction;
		ActionFindOpenFile: TAction;
		Find2: TMenuItem;
		Replace1: TMenuItem;
		OpenFileAtCursor1: TMenuItem;
		N13: TMenuItem;
		FindDlg: TFindDialog;
		ReplaceDlg: TReplaceDialog;
		ToolBarImagesDisabled: TImageList;
		PrintDlg: TPrintDialog;
		ActionFilePrint: TAction;
		Print1: TMenuItem;
		N14: TMenuItem;
		ActionFilePrintQuickly: TAction;
		ErrorListIcons: TImageList;
		DocFile: THTMLHelp;
		ActionHelpContents: TAction;
		ActionHelpIndex: TAction;
		ActionHelpSearch: TAction;
		ActionTreeItemRename: TAction;
		N19: TMenuItem;
		Rename1: TMenuItem;
		Contents1: TMenuItem;
		Index1: TMenuItem;
		Search1: TMenuItem;
		EditorPopup: TPopupMenu;
		Undo2: TMenuItem;
		N16: TMenuItem;
		Clear1: TMenuItem;
		Cut2: TMenuItem;
		Copy2: TMenuItem;
		Paste2: TMenuItem;
		N17: TMenuItem;
		SelectAll2: TMenuItem;
		MainToolBar: TToolBar;
    ToolBarNewButton: TToolButton;
		ToolButton2: TToolButton;
		ToolButton3: TToolButton;
		ToolButton4: TToolButton;
		ToolButton23: TToolButton;
		ToolButton24: TToolButton;
		ToolButton6: TToolButton;
		ToolButton7: TToolButton;
		ToolButton8: TToolButton;
		ToolButton9: TToolButton;
		ToolButton10: TToolButton;
		ToolButton5: TToolButton;
		ToolButton11: TToolButton;
		ToolButton20: TToolButton;
		ToolButton21: TToolButton;
    ToolBarCompileLine1: TToolButton;
    ToolBarCompileButton: TToolButton;
		ToolButton15: TToolButton;
		ToolBarCompileLine2: TToolButton;
		ToolButton18: TToolButton;
		ToolButton19: TToolButton;
		ActionEditRedo: TAction;
		Redo1: TMenuItem;
		Redo2: TMenuItem;
		EditorPanel: TPanel;
		NoEditor: TPanel;
		FunctionPopup: TPopupMenu;
		ActionFindFunctions: TAction;
		N15: TMenuItem;
		Functions1: TMenuItem;
		ToolButton25: TToolButton;
		NoFunctionsItem: TMenuItem;
		ActionFileNewTextFile: TAction;
		TextFile1: TMenuItem;
		TextFile2: TMenuItem;
		ActionEditIncreaseIndent: TAction;
		ActionEditDecreaseIndent: TAction;
		N18: TMenuItem;
		IncreaseIndent1: TMenuItem;
		DecreaseIndent1: TMenuItem;
		N20: TMenuItem;
		IncreaseIndent2: TMenuItem;
		DecreaseIndent2: TMenuItem;
		N21: TMenuItem;
		OpenFileatCursor2: TMenuItem;
		ActionFileNewGNUAsmFile: TAction;
		GNUAssemblySourceFile1: TMenuItem;
		GNUAssemblySourceFile2: TMenuItem;
		ActionFileNewQuillFile: TAction;
		QuillSourceFile1: TMenuItem;
		QuillSourceFile2: TMenuItem;
		ActionProjectStopCompilation: TAction;
		ActionProjectForceQuitCompiler: TAction;
		ToolButton16: TToolButton;
		ToolButton17: TToolButton;
		StopCompilation1: TMenuItem;
		ForceQuitCompiler1: TMenuItem;
		ActionHelpNews: TAction;
		N3: TMenuItem;
		News1: TMenuItem;
		ActionDebugRun: TAction;
		ActionDebugPause: TAction;
		ActionDebugReset: TAction;
		MainMenuDebug: TMenuItem;
		Run1: TMenuItem;
		N22: TMenuItem;
		Pause1: TMenuItem;
		Reset1: TMenuItem;
		ToolBarRunButton: TToolButton;
		ToolBarDebugLine: TToolButton;
		ToolBarPauseButton: TToolButton;
		ToolButton12: TToolButton;
		ToolButton13: TToolButton;
    ChangeNotificationTimer: TTimer;
		ToolBarBevel: TBevel;
    ToolBarEndLine: TToolButton;
    RecentFilesLine: TMenuItem;
    RecentFilesPopup: TPopupMenu;
		NoFilesItem: TMenuItem;
		ActionToolsConfigure: TAction;
		MainMenuTools: TMenuItem;
		Configure1: TMenuItem;
		ToolsLine: TMenuItem;
		ActionProjectShowProgramOutput: TAction;
		ProgramOutput1: TMenuItem;
		procedure FormCreate(Sender: TObject);
		procedure FormDestroy(Sender: TObject);
		procedure AppException(Sender: TObject; E: Exception);
		procedure ProjectTreeEditing(Sender: TObject; Node: TTreeNode;
			var AllowEdit: Boolean);
		procedure ProjectAddFiles(Sender: TObject);
		procedure ProjectTreeChange(Sender: TObject; Node: TTreeNode);
		procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
		procedure ProjectTreeDeletion(Sender: TObject; Node: TTreeNode);
		procedure FileExit(Sender: TObject);
		procedure FileNewProject(Sender: TObject);
		procedure TreeItemRemove(Sender: TObject);
		procedure TreeItemDelete(Sender: TObject);
		procedure TreeItemCompile(Sender: TObject);
		procedure CloseErrorsButtonClick(Sender: TObject);
		procedure ErrorListDeletion(Sender: TObject; Item: TListItem);
		procedure TreeItemSave(Sender: TObject);
		procedure HelpDocumentation(Sender: TObject);
		procedure EditorEnter(Sender: TObject);
		procedure EditorExit(Sender: TObject);
		procedure EditUndo(Sender: TObject);
		procedure EditRedo(Sender: TObject);
		procedure EditClear(Sender: TObject);
		procedure EditCut(Sender: TObject);
		procedure EditCopy(Sender: TObject);
		procedure EditPaste(Sender: TObject);
		procedure EditSelectAll(Sender: TObject);
		procedure ProjectCompile(Sender: TObject);
		procedure ProjectMake(Sender: TObject);
		procedure FileOpenProject(Sender: TObject);
		procedure FileSaveAll(Sender: TObject);
		procedure FileSaveProjectAs(Sender: TObject);
		procedure EditorKeyDown(Sender: TObject; var Key: Word;
			Shift: TShiftState);
		procedure ProjectBuild(Sender: TObject);
		procedure ProjectTreeKeyDown(Sender: TObject; var Key: Word;
			Shift: TShiftState);
		procedure ProjectTreeMouseUp(Sender: TObject; Button: TMouseButton;
			Shift: TShiftState; X, Y: Integer);
		procedure ProjectTreeEdited(Sender: TObject; Node: TTreeNode;
			var S: String);
		procedure ProjectOptions(Sender: TObject);
		procedure FilePreferences(Sender: TObject);
		procedure FileNewHeaderFile(Sender: TObject);
		procedure FileNewCSourceFile(Sender: TObject);
		procedure FileNewGNUAssemblerSourceFile(Sender: TObject);
		procedure FileNewAssemblerSourceFile(Sender: TObject);
		procedure FileNewQuillSourceFile(Sender: TObject);
		procedure FileNewTextFile(Sender: TObject);
		procedure TreeItemSaveAs(Sender: TObject);
		procedure HelpAbout(Sender: TObject);
		procedure DisplayHint(Sender: TObject);
		procedure ShowHideErrors(Sender: TObject);
		procedure FindString(Sender: TObject; AllFiles: Boolean);
		procedure ReplaceDlgReplace(Sender: TObject);
		procedure FindText(Sender: TObject);
		procedure ReplaceText(Sender: TObject);
		procedure FindAndOpenFile(Sender: TObject);
		procedure FindDlgFind(Sender: TObject);
		procedure ActionsExecute(Action: TBasicAction; var Handled: Boolean);
		procedure ProjectTreeEnter(Sender: TObject);
		procedure ProjectTreeExit(Sender: TObject);
		procedure ProjectTreeChanging(Sender: TObject; Node: TTreeNode;
			var AllowChange: Boolean);
		procedure EditorChange(Sender: TObject);
		procedure FilePrint(Sender: TObject);
		procedure FilePrintQuickly(Sender: TObject);
		procedure TreeItemRename(Sender: TObject);
		procedure HelpContents(Sender: TObject);
		procedure HelpIndex(Sender: TObject);
		procedure HelpSearch(Sender: TObject);
		procedure SplitterMoved(Sender: TObject);
		procedure ProjectTreeMouseDown(Sender: TObject; Button: TMouseButton;
			Shift: TShiftState; X, Y: Integer);
		procedure ToolBarManagerBandMove(Sender: TObject; Control: TControl;
			var ARect: TRect);
		procedure ProjectTreeDragOver(Sender, Source: TObject; X, Y: Integer;
			State: TDragState; var Accept: Boolean);
		procedure ProjectTreeDragDrop(Sender, Source: TObject; X, Y: Integer);
		procedure ErrorListClick(Sender: TObject);
		procedure DeleteError(Sender: TObject);
		procedure FunctionPopupPopup(Sender: TObject);
		procedure FindFunctions(Sender: TObject);
		procedure FindFunctionFromPopup(Sender: TObject);
		procedure IncreaseIndent(Sender: TObject);
		procedure DecreaseIndent(Sender: TObject);
		procedure ProjectStopCompilation(Sender: TObject);
		procedure ProjectForceQuitCompiler(Sender: TObject);
		procedure HelpNews(Sender: TObject);
		procedure DebugRun(Sender: TObject);
		procedure DebugPause(Sender: TObject);
		procedure DebugReset(Sender: TObject);
		procedure FormKeyDown(Sender: TObject; var Key: Word;
			Shift: TShiftState);
		procedure ChangeNotificationTick(Sender: TObject);
		procedure RecentFileClick(Sender: TObject);
		procedure ToolsConfigure(Sender: TObject);
		procedure ToolClick(Sender: TObject);
		procedure ProjectTreeStartDrag(Sender: TObject;
			var DragObject: TDragObject);
		procedure ShowProgramOutput(Sender: TObject);
	private
		EditorToHide: TWinControl;
		TempLockHandle: THandle;
		FModified: Boolean;
		FInvalidated: Boolean;
		FProjectFile: string;
		InChangeNotification: Boolean;
		procedure WMDropFiles(var Msg: TMessage); message WM_DROPFILES;
		procedure SetProjectFile(const Value: string);
		procedure SetModified(const Value: Boolean);
		function GetCurrentEditor: TMemoComponent;
		function GetInvalidated: Boolean;
	public
		TopNode: TTreeNode;
		OriginalCaption: string;
		SourceFiles: TSourceFiles;
		OpenFolderMessage,
		TemplateWizard,
		AutoSave,
		DeleteErrors,
		StartingAppNow,
		OpeningProjectNow,
		NoHideEditor: Boolean;
		PreviousNode: TTreeNode;
		SyntaxCBackup: TSyntaxColoring;
		SyntaxAsmGNUBackup: TSyntaxColoring;
		SyntaxAsmBackup: TSyntaxColoring;
		SyntaxQuillBackup: TSyntaxColoring;
		Closing: Boolean;
		ProgSize: Integer;
		Funcs: TSourceFileFunctions;
		CurrentSymbols: TCOFFSymbols;
		CurrentStrings: TMemoryStream;
		CurVTIType: TCurVTIType;
		RecentFiles: TStringList;
		ToolsList: TToolsList;
		property ProjectFile: string read FProjectFile write SetProjectFile;
		property Modified: Boolean read FModified write SetModified;
		property Invalidated: Boolean read GetInvalidated write FInvalidated;
		property CurrentEditor: TMemoComponent read GetCurrentEditor;
		procedure Modify;
		procedure WarnIfModified;
		procedure FileNew;
		procedure FileLoad;
		procedure FileOpen(const FN: string);
		procedure FileSave;
		procedure FileSaveAs(const FN: string);
		procedure ResetProjectSettings;
		procedure AppCompStartFile;
		procedure AppCompStop;
		procedure AppCompSetMessage(const Msg: string);
		procedure AppCompUpdate;
		procedure UpdateProgramOutput;
		procedure CopyHeaders;
		procedure DeleteHeaders;
		procedure ClearErrors;
		procedure HideErrors;
		procedure ShowErrors;
		procedure UpdateErrorWindow;
		procedure AddError(const Line: string; BugTp: TBugType; SourceF: string; ErrFunc: string; ErrMessage: string; SourceLn: Integer; Offset: Integer);
		procedure CompileProject;
		procedure MakeFileWrapped;
		procedure MakeFile;
		function AddSourceFile(const FN: string; OpenOnly: Boolean = False; SourceFileClass: TSourceFileClass = nil): TSourceFile;
		procedure LoadPreferences;
		procedure SavePreferences;
		procedure BeginCompilation;
		procedure EndCompilation;
		procedure RecompileFiles;
		procedure UpdateEditButtons;
		procedure UpdateStatusBar;
		procedure UpdateFuncs;
		procedure UpdateDebugSettings;
		procedure SortFiles;
		procedure DisplayFolderMessage;
		procedure ClearDebugInfo;
		function GetVTIWindow: HWnd;
		procedure SendFiles(FNList: array of string);
		procedure ExecuteCommandLine(const Line: string);
		procedure SelectNode(Node: TTreeNode);
		procedure AddToRecent(const FileName: string);
		procedure UpdateRecent;
		procedure AddTool(const Title, CommandLine, WorkingDir: string; WindowState: TWindowState);
	end;

var
	MainForm: TMainForm;

type
	TRecentFileMenuItem = class(TObject)
		FileMenuItem: TMenuItem;
		PopupMenuItem: TMenuItem;
	public
		destructor Destroy; override;
	end;

const
	MaxRecentFiles = 4;

type
	TNoImageDragObject = class(TDragControlObject)
	public
		function GetDragImages: TDragImageList; override;
		procedure HideDragImage; override;
		procedure ShowDragImage; override;
	end;

implementation

{$R *.DFM}

uses
	ParsingUnit, ProcessUnit,
	StartupScreenUnit, PreferencesUnit, ProjectOptionsUnit,
	AboutUnit, TemplateWizardUnit, SourceFileWinUnit, FunctionsWinUnit,
	OpenFileStatusUnit, NewsUnit, SendProgressUnit, ToolsUnit,
	ProgramOutputUnit, VTIStartUnit,
	LinkImportUnit,
	UtilsDos, UtilsWin, HandleWaitThreadUnit, FileReadToBufferThreadUnit,
	ShellAPI, IniFiles, Registry, WinSpool;

const
	RegKey = '\Software\SeReSoft\TI-GCC IDE';

var
	ProcID: Cardinal;
	SendWin: HWnd;

function EnumWindowsFunc(Win: HWnd; Param: Integer): Bool; stdcall;
var
	Name: array [0..32] of Char;
	NewProcID: DWord;
begin
	Result := True;
	GetWindowThreadProcessID (Win, @NewProcID);
	if NewProcID = ProcID then begin
		GetClassName (Win, Name, 32);
		if Name = '#32770' then begin
			Result := False;
			SendWin := Win;
		end;
	end;
end;

procedure ErrorMessage(const Msg: string);
begin
	if UpperCase (Copy (Msg, 1, Length ('ERROR:'))) = 'ERROR:' then
		MainForm.AddError (Msg, btError, '', '', Trim (Copy (Msg, Length ('ERROR:') + 1, Length (Msg))), 0, 0)
	else if UpperCase (Copy (Msg, 1, Length ('WARNING:'))) = 'WARNING:' then
		MainForm.AddError (Msg, btWarning, '', '', Trim (Copy (Msg, Length ('WARNING:') + 1, Length (Msg))), 0, 0);
end;

{ TRecentFileMenuItem }

destructor TRecentFileMenuItem.Destroy;
begin
	FileMenuItem.Free;
	PopupMenuItem.Free;
	inherited;
end;

{ TNoImageDragObject }

function TNoImageDragObject.GetDragImages: TDragImageList;
begin
	Result := nil;
end;

procedure TNoImageDragObject.HideDragImage;
begin
end;

procedure TNoImageDragObject.ShowDragImage;
begin
end;

{ TMainForm }

procedure TMainForm.Modify;
begin
	Modified := True;
end;

procedure TMainForm.FormCreate(Sender: TObject);
var
	TempDir: array [0..255] of Char;
	S: string;
	TempLockData: TWin32FindData;
begin
	StartingAppNow := True;
	try
		if Assigned (StartupScreenForm) then
			StartupScreenForm.DisplayText := 'Setting Up Environment...';
		Application.OnException := AppException;
		WindowState := wsMaximized;
		RecentFiles := TStringList.Create;
		ToolsList := TToolsList.Create (Self, TToolsListItem);
		TIGCCFolder := ExtractFilePath (ParamStr (0));
		Delete (TIGCCFolder, Pos (UpperCase (IDELocation), UpperCase (TIGCCFolder)), Length (TIGCCFolder));
		with TRegistry.Create do try
			RootKey := HKey_Local_Machine;
			if OpenKeyReadOnly ('\Software\TIGCC Team\TIGCC') then try
				if ValueExists ('Program Folder') then
					TIGCCFolder := ReadString ('Program Folder');
			except end;
		finally
			Free;
		end;
		try
			if FileExists (WithBackslash (TIGCCFolder) + A68kLocation + 'A68k.exe') then
				Include (SpecialSupport, ssA68k);
		except end;
		try
			if FileExists (WithBackslash (TIGCCFolder) + QuillIncludeLocation + 'Quill.drv')
				or FileExists (WithBackslash (TIGCCFolder) + CIncludeLocation + 'Quill.drv')
				or FileExists (WithBackslash (TIGCCFolder) + GCCLocation + 'Quill.drv') then
				Include (SpecialSupport, ssQuill);
		except end;
		try
			if FileExists (WithBackslash (TIGCCFolder) + PackLocation + 'Pack.exe') then
				Include (SpecialSupport, ssPack);
		except end;
		try
			if FileExists (WithBackslash (TIGCCFolder) + ArLocation + 'Ar.exe') then
				Include (SpecialSupport, ssAr);
		except end;
		CompStartFile := AppCompStartFile;
		CompStop := AppCompStop;
		CompSetMessage := AppCompSetMessage;
		CompUpdate := AppCompUpdate;
		CompUpdateProgramOutput := UpdateProgramOutput;
		SourceFiles := TSourceFiles.Create;
		SyntaxCBackup := TSyntaxColoring.Create (nil);
		SyntaxCBackup.Assign (SyntaxC);
		SyntaxAsmGNUBackup := TSyntaxColoring.Create (nil);
		SyntaxAsmGNUBackup.Assign (SyntaxAsmGNU);
		SyntaxAsmBackup := TSyntaxColoring.Create (nil);
		if ssA68k in SpecialSupport then
			SyntaxAsmBackup.Assign (SyntaxAsm);
		SyntaxQuillBackup := TSyntaxColoring.Create (nil);
		if ssQuill in SpecialSupport then
			SyntaxQuillBackup.Assign (SyntaxQuill);
		TopNode := ProjectTree.Items.Item [0];
		SourceFileUnit.AppNode := TopNode;
		SourceFileUnit.NoEditor := NoEditor;
		OriginalCaption := Caption;
		Application.OnHint := DisplayHint;
		if ssA68k in SpecialSupport then begin
			ActionFileNewA68kAsmFile.Visible := True;
			with ProjectTree.Items.Insert (TopNode.Item [TAsmSourceFile.GetClassTreeIndex], 'A68k Assembly Files') do begin
				ImageIndex := TopNode.Item[0].ImageIndex;
				SelectedIndex := TopNode.Item[0].SelectedIndex;
			end;
		end;
		if ssQuill in SpecialSupport then begin
			ActionFileNewQuillFile.Visible := True;
			S := OpenProjectDlg.Filter;
			Insert (TQuillSourceFile.GetClassFilter + '|', S, Pos (TNormalTextSourceFile.GetClassFilter, S));
			while Pos ('*.asm;*.txt', S) > 0 do
				Insert (';*.qll', S, Pos ('*.asm;*.txt', S) + Length ('*.asm'));
			OpenProjectDlg.Filter := S;
			OpenProjectDlg.FilterIndex := OpenProjectDlg.FilterIndex + 1;
			S := AddFileDlg.Filter;
			Insert (TQuillSourceFile.GetClassFilter + '|', S, Pos (TObjectSourceFile.GetClassFilter, S));
			while Pos ('*.asm;*.o', S) > 0 do
				Insert (';*.qll', S, Pos ('*.asm;*.o', S) + Length ('*.asm'));
			AddFileDlg.Filter := S;
			AddFileDlg.FilterIndex := AddFileDlg.FilterIndex + 1;
			with ProjectTree.Items.Insert (TopNode.Item [TQuillSourceFile.GetClassTreeIndex], 'Quill Files') do begin
				ImageIndex := TopNode.Item[0].ImageIndex;
				SelectedIndex := TopNode.Item[0].SelectedIndex;
			end;
		end;
		ProjectTree.FullExpand;
		ResetProjectSettings;
		TemplateWizard := True;
		AssumeUndefined := False;
		AutoSave := True;
		AutoNews := False;
		LastNewsDate := 0;
		GetTempPath (SizeOf (TempDir), TempDir);
		Temp := AnsiString (TempDir);
		if (Length (Temp) <= 0) or (not DirExists (Temp)) then begin
			GetEnvironmentVariable ('TMP', TempDir, SizeOf (TempDir));
			Temp := AnsiString (TempDir);
		end;
		if (Length (Temp) <= 0) or (not DirExists (Temp)) then begin
			GetEnvironmentVariable ('TEMP', TempDir, SizeOf (TempDir));
			Temp := AnsiString (TempDir);
		end;
		if (Length (Temp) <= 0) or (Length (Temp) > 30) or (Pos (' ', Temp) > 0) or (Pos ('TEMP', UpperCase (Temp)) <= 0) then begin
			GetWindowsDirectory (TempDir, SizeOf (TempDir));
			Temp := WithBackslash (AnsiString (TempDir)) + 'TEMP\';
			if not DirExists (Temp) then try
				MkDir (Temp);
			except end;
		end;
		if (Length (Temp) <= 0) or (Length (Temp) > 30) or (Pos (' ', Temp) > 0) then begin
			Temp := 'C:\TEMP\';
			if not DirExists (Temp) then try
				MkDir (Temp);
			except end;
		end;
		Temp := WithBackslash (Temp) + IntToHex (GetCurrentProcessID, 8) + '\';
		if not DirExists (Temp) then try
			MkDir (Temp);
		except end;
		TempLockHandle := Windows.FindFirstFile (PChar (Temp + '*.*'), TempLockData);
		StopOnErrors := False;
		OpenFolderMessage := True;
		DeleteAssemblyFiles := True;
		DeleteObjectFiles := False;
{$IFDEF CanSplit}
		SplitFiles := True;
{$ENDIF}
		DeleteErrors := True;
		TransferTarget := ttVTI;
		LinkPort := CALC_PORT_COM1;
		LinkCable := CALC_CABLE_BLACKLINK;
		TabSizeAsm := 8;
		TabSizeC := 2;
		AutoBlocks := True;
		EditorOnFly := True;
		EditorDragDrop := True;
		if Assigned (StartupScreenForm) then
			StartupScreenForm.DisplayText := 'Loading Preferences...';
		try
			LoadPreferences;
		except
			ShowDefaultMessageBox ('An error occured while loading the preferences. Some parts of the program may not be configured correctly.', 'Error', mtProgramError);
		end;
		DocFile.FileName := WithBackslash (TIGCCFolder) + DocLocation + 'TIGCC.chm';
		if FileExists (WithBackslash (TIGCCFolder) + TIPatchLocation + 'TIPatch.lib') then try
			PatchLib.LoadFromFile (WithBackslash (TIGCCFolder) + TIPatchLocation + 'TIPatch.lib');
		except
			on E: Exception do
				ShowDefaultMessageBox ('TIPatch.lib: ' + E.Message, 'Error', mtProgramError);
		end else
			PatchLib.Clear;
		if FileExists (WithBackslash (TIGCCFolder) + TIPatchLocation + 'TIPatchMain.lib') then try
			PatchMainLib.LoadFromFile (WithBackslash (TIGCCFolder) + TIPatchLocation + 'TIPatchMain.lib');
		except
			on E: Exception do
				ShowDefaultMessageBox ('TIPatchMain.lib: ' + E.Message, 'Error', mtProgramError);
		end else
			PatchMainLib.Clear;
		if DirExists (WithBackslash (TIGCCFolder) + ProjectsLocation) then
			OpenProjectDlg.InitialDir := WithBackslash (TIGCCFolder) + ProjectsLocation
		else
			OpenProjectDlg.InitialDir := TIGCCFolder;
		SaveProjectDlg.InitialDir := OpenProjectDlg.InitialDir;
		AddFileDlg.InitialDir := OpenProjectDlg.InitialDir;
		DragAcceptFiles (Handle, True);
		ParsingUnit.ErrorMessageProc := ErrorMessage;
		S := '';
		if ParamCount > 0 then begin
			if LowerCase (ExtractFileExt (ParamStr (1))) = LowerCase (ProjectFileExt) then
				ProjectFile := ExpandFileName (ParamStr (1))
			else
				S := ExpandFileName (ParamStr (1));
		end;
		if Length (ProjectFile) > 0 then begin
			if Assigned (StartupScreenForm) then
				StartupScreenForm.DisplayText := 'Opening Project...';
			FileLoad;
		end;
		if Length (S) > 0 then
			AddSourceFile (S, True);
		if AutoNews then begin
			if Assigned (StartupScreenForm) then
				StartupScreenForm.DisplayText := 'Downloading Headlines...';
			with TNewsForm.Create (Self) do begin
				SilentConnect := True;
				Connect;
			end;
		end;
	except
		ShowDefaultMessageBox ('An error occured while setting up the application. Some parts of the program may not be configured correctly.', 'Error', mtProgramError);
	end;
	StartingAppNow := False;
end;

procedure TMainForm.FormDestroy(Sender: TObject);
var
	I: Integer;
begin
	Closing := True;
	ClearDebugInfo;
	ErrorList.Items.Clear;
	SourceFiles.Free;
	SyntaxQuillBackup.Free;
	SyntaxAsmBackup.Free;
	SyntaxAsmGNUBackup.Free;
	SyntaxCBackup.Free;
	if TempLockHandle <> INVALID_HANDLE_VALUE then
		Windows.FindClose (TempLockHandle);
	try
		RmDir (Temp);
	except end;
	ToolsList.Free;
	with RecentFiles do begin
		for I := Count - 1 downto 0 do
			Objects[I].Free;
		Free;
	end;
end;

procedure TMainForm.AppException(Sender: TObject; E: Exception);
begin
	if not (E is ESocketError) then
		ShowDefaultMessageBox ('Internal Error: Exception ' + E.ClassName + ', Message "' + E.Message + '"'#13#10#13#10'Please fill out a bug report form at http://tigcc.ticalc.org/.', 'Internal Error', mtProgramError);
end;

procedure TMainForm.ProjectTreeEditing(Sender: TObject; Node: TTreeNode;
	var AllowEdit: Boolean);
begin
	AllowEdit := Assigned (Node.Data) or not Assigned (Node.Parent);
end;

procedure TMainForm.ProjectAddFiles(Sender: TObject);
var
	I: Integer;
	F: TSourceFile;
begin
	if AddFileDlg.Execute then begin
		for I := AddFileDlg.Files.Count - 1 downto 0 do begin
			F := AddSourceFile(ExpandFileName(AddFileDlg.Files[I]));
			if (I = 0) and Assigned (F) and Assigned (F.TreeItem) then
				SelectNode (F.TreeItem);
		end;
		Modify;
	end else
		Abort;
end;

procedure TMainForm.ProjectTreeChange(Sender: TObject; Node: TTreeNode);
var
	NewEditor: TWinControl;
	IsMemo: Boolean;
begin
	PreviousNode := ProjectTree.Selected;
	if not (Closing or StartingAppNow) then begin
		if Assigned (ProjectTree.Selected) and Assigned (ProjectTree.Selected.Data) then
			NewEditor := TSourceFile(ProjectTree.Selected.Data).Editor
		else
			NewEditor := NoEditor;
		if Assigned (EditorToHide) and (EditorToHide <> NewEditor) then
			EditorToHide.Align := alNone;
		if NewEditor.Align <> alClient then
			NewEditor.Align := alClient;
		IsMemo := NewEditor is TMemoComponent;
		if IsMemo then
			TMemoComponent(NewEditor).DrawingSuspended := True;
		NewEditor.Show;
		Update;
		if IsMemo then
			with TMemoComponent (NewEditor) do begin
				DrawingSuspended := False;
				Repaint;
			end;
		if Assigned (EditorToHide) and (EditorToHide <> NewEditor) then
			EditorToHide.Hide;
		EditorToHide := nil;
		if ActiveControl = ProjectTree then
			ActionEditDelete.Enabled := Assigned (ProjectTree.Selected) and Assigned (ProjectTree.Selected.Data);
		ActionFilePrint.Enabled := Assigned (ProjectTree.Selected) and Assigned (ProjectTree.Selected.Data) and TSourceFile(ProjectTree.Selected.Data).Printable and (Printer.Printers.Count > 0);
		ActionFilePrintQuickly.Enabled := ActionFilePrint.Enabled;
		ActionFindFunctions.Enabled := Assigned (ProjectTree.Selected) and Assigned (ProjectTree.Selected.Data) and (TSourceFile (ProjectTree.Selected.Data) is TSourceTextSourceFile);
		UpdateStatusBar;
	end;
end;

procedure TMainForm.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
	if Compiling then
		CanClose := False
	else
		try
			WarnIfModified;
			SavePreferences;
		except
			CanClose := False;
		end;
end;

procedure TMainForm.WarnIfModified;
var
	I: Integer;
begin
	if Modified then
		case ShowDefaultMessageBox
			('The current project has been modified.  Do you want to save the changes?',
			'Project Modified', mtQuestion, True) of
			idYes: FileSave;
			idCancel: Abort;
		end;
	with SourceFiles do
		for I := 0 to Count - 1 do
			with Items [I] as TSourceFile do
				WarnIfModified;
end;

procedure TMainForm.FileLoad;
var
	F: TOpenFileStatusForm;
	I: Integer;
	S,
	P: string;
	SL: TStringList;
begin
	if not Compiling then begin
		WarnIfModified;
		Modified := False;
		OpeningProjectNow := True;
		Update;
		F := nil;
		ProjectTree.Items.BeginUpdate;
		S := ProjectFile;
		try
			FileNew;
			if (Length (S) > 0) and FileExists (S) then begin
				if not StartingAppNow then begin
					try
						F := TOpenFileStatusForm.Create (Self);
					except
						F := nil;
					end;
					if Assigned (F) then begin
						P := ExtractFileName (S);
						F.FileNameLabel.Caption := 'Opening Project ''' + Copy (P, 1, LastPos ('.', P) - 1) + '''...';
						F.Show;
						F.Update;
					end;
				end;
				OpenProjectDlg.InitialDir := WithoutBackslash (ExtractFilePath (S));
				OpenProjectDlg.FileName := S;
				SaveProjectDlg.InitialDir := WithoutBackslash (ExtractFilePath (S));
				SaveProjectDlg.FileName := S;
				with TIniFile.Create (S) do try
					TopNode.Text := ReadString ('Settings', 'Project Name', 'Project1');
					ProjectFile := S;
					if (ssAr in SpecialSupport) and ReadBool ('Settings', 'Archive', False) then
						ProjectTarget := ptArchive;
					Pack := ReadBool ('Settings', 'Pack', False);
					PackVar := ReadString ('Settings', 'Packed Variable', '');
					GCCSwitches := ReadString ('Settings', 'GCC Switches', '');
					AsSwitches := ReadString ('Settings', 'GNU Assembler Switches', '');
					AsmSwitches := ReadString ('Settings', 'Assembler Switches', '');
					LdSwitches := ReadString ('Settings', 'GNU Linker Switches', '');
					LinkSwitches := ReadString ('Settings', 'Linker Switches', '');
					DebugInfo := ReadBool ('Settings', 'Debug Info', False);
					StdLib := ReadBool ('Settings', 'Standard Library', True);
					CommandLine := ReadString ('Settings', 'Command Line', '');
					PostBuildProcessFile := ReadString ('Settings', 'Post-Build Process', '');
					while Pos ('`', PostBuildProcessFile) > 0 do
						PostBuildProcessFile [Pos ('`', PostBuildProcessFile)] := '"';
					SL := TStringList.Create;
					try
						ReadSection ('Included Files', SL);
						for I := 0 to SL.Count - 1 do begin
							S := ReadString ('Included Files', SL [I], '');
							if Length (S) > 0 then begin
								if Pos (':', S) <= 0 then
									S := ExtractFilePath (ProjectFile) + S;
								if FileExists (S) then
									AddSourceFile (S, False, TSourceFile.GetAppropriateClassFromName (Copy (SL [I], 1, LastPos (' ', SL [I]) - 1)))
								else
									ShowDefaultMessageBox ('File not found:'#13#10#13#10 + S, 'Error', mtProgramError);
							end;
						end;
					finally
						SL.Free;
					end;
				finally
					Free;
				end;
				ProjectTree.FullExpand;
				NoEditor.Show;
				UpdateDebugSettings;
				AddToRecent (ProjectFile);
			end;
		finally
			ProjectTree.Items.EndUpdate;
			OpeningProjectNow := False;
			if Assigned (F) then
				F.Free;
		end;
		Modified := False;
	end;
end;

procedure TMainForm.FileNew;
var
	I: Integer;
begin
	if not Compiling then begin
		WarnIfModified;
		Modified := False;
		Invalidated := True;
		ActiveControl := ProjectTree;
		ErrorList.Items.BeginUpdate;
		ErrorList.Items.Clear;
		ErrorList.Items.EndUpdate;
		ProjectTree.Items.BeginUpdate;
		ProjectFile := '';
		ClearDebugInfo;
		TopNode.Text := 'Project1';
		with SourceFiles do
			for I := Count - 1 downto 0 do
				with Items [I] do
					Free;
		SelectNode (TopNode);
		ProjectTree.FullExpand;
		ProjectTree.Items.EndUpdate;
		ResetProjectSettings;
		NoEditor.Show;
		UpdateDebugSettings;
		Update;
		Modified := False;
	end;
end;

procedure TMainForm.FileOpen(const FN: string);
begin
	if not Compiling then begin
		WarnIfModified;
		Modified := False;
		ProjectTree.Items.BeginUpdate;
		ProjectFile := FN;
		FileLoad;
		ProjectTree.Items.EndUpdate;
	end;
end;

procedure TMainForm.FileSave;
var
	I,
	ClassCount: Integer;
	S: string;
	SL: TStringList;
begin
	if ProjectFile = '' then
		FileSaveProjectAs (Self)
	else begin
		OpenProjectDlg.InitialDir := WithoutBackslash (ExtractFilePath (ProjectFile));
		OpenProjectDlg.FileName := ProjectFile;
		SaveProjectDlg.InitialDir := WithoutBackslash (ExtractFilePath (ProjectFile));
		SaveProjectDlg.FileName := ProjectFile;
		try
			with SourceFiles do
				for I := 0 to Count - 1 do
					with Items [I] as TSourceFile do begin
						if UpperCase (ExtractFilePath (FileName)) = 'C:\' then
							FileName := ExtractFilePath (ProjectFile) + ExtractFileName (FileName);
						if Modified or not FileExists (FileName) then
							Save;
					end;
			with TIniFile.Create (ProjectFile) do try
				WriteBool ('Settings', 'Archive', ProjectTarget = ptArchive);
				WriteBool ('Settings', 'Pack', Pack);
				WriteString ('Settings', 'Packed Variable', PackVar);
				WriteString ('Settings', 'Project Name', TopNode.Text);
				WriteString ('Settings', 'GCC Switches', GCCSwitches);
				WriteString ('Settings', 'GNU Assembler Switches', AsSwitches);
				WriteString ('Settings', 'Assembler Switches', AsmSwitches);
				WriteString ('Settings', 'GNU Linker Switches', LdSwitches);
				WriteString ('Settings', 'Linker Switches', LinkSwitches);
				WriteBool ('Settings', 'Debug Info', DebugInfo);
				WriteBool ('Settings', 'Standard Library', StdLib);
				WriteString ('Settings', 'Command Line', CommandLine);
				S := PostBuildProcessFile;
				while Pos ('"', S) > 0 do
					S [Pos ('"', S)] := '`';
				WriteString ('Settings', 'Post-Build Process', S);
				EraseSection ('Included Files');
				SL := TStringList.Create;
				try
					with SourceFiles do
						for I := 0 to Count - 1 do
							with Items [I] as TSourceFile do
								if InProject then begin
									S := SL.Values [ClassItemName];
									if Length (S) > 0 then
										ClassCount := StrToInt (S) + 1
									else
										ClassCount := 1;
									SL.Values [ClassItemName] := IntToStr (ClassCount);
									WriteString ('Included Files', ClassItemName + ' ' + IntToStr (ClassCount), DynamicName);
								end;
				finally
					SL.Free;
				end;
				UpdateFile;
			finally
				Free;
			end;
			Modified := False;
		except
			ShowDefaultMessageBox ('Error saving project file.', 'Error', mtProgramError);
		end;
		AddToRecent (ProjectFile);
	end;
end;

procedure TMainForm.FileSaveAs(const FN: string);
var
	I: Integer;
begin
	with SourceFiles do
		for I := 0 to Count - 1 do
			with Items [I] as TSourceFile do
				if Pos ('\', DynamicName) <= 0 then
					SaveAsName (ExtractFilePath (FN) + DynamicName);
	ProjectFile := FN;
	FileSave;
end;

procedure TMainForm.ProjectTreeDeletion(Sender: TObject; Node: TTreeNode);
begin
	PreviousNode := nil;
	EditorToHide := nil;
	if Assigned (Node.Data) then
		with TSourceFile (Node.Data) do begin
			TreeItem := nil;
			Free;
		end;
	ProjectTree.Invalidate;
end;

procedure TMainForm.FileExit(Sender: TObject);
begin
	Close;
end;

procedure TMainForm.FileNewProject(Sender: TObject);
begin
	WarnIfModified;
	Modified := False;
	FileNew;
end;

procedure TMainForm.TreeItemRemove(Sender: TObject);
begin
	if (not Compiling) and Assigned (ProjectTree.Selected) and Assigned (ProjectTree.Selected.Data) then begin
		TSourceFile(ProjectTree.Selected.Data).WarnIfModified;
		ProjectTree.Selected.Delete;
		Modify;
	end;
end;

procedure TMainForm.TreeItemDelete(Sender: TObject);
begin
	if (not Compiling) and Assigned (ProjectTree.Selected) and Assigned (ProjectTree.Selected.Data) then
		if ShowDefaultMessageBox
			('Are you sure you want to delete this source file?  You cannot undo this operation.',
			'Confirm Deletion', mtQuestion) = idYes then begin
			with TSourceFile (ProjectTree.Selected.Data) do
				if (FileName <> '') and FileExists (FileName) then
					DeleteFile (FileName);
			ProjectTree.Selected.Delete;
			Modify;
		end;
end;

procedure TMainForm.CopyHeaders;
var
	I,
	J: Integer;
	HasA68kFiles: Boolean;
begin
	HasA68kFiles := False;
	with SourceFiles do begin
		for I := 0 to Count - 1 do
			if Items [I] is TAsmSourceFile then begin
				HasA68kFiles := True;
				Break;
			end;
		if HasA68kFiles then
			with TFileReferences.Create do try
				SearchForFiles (WithBackslash (TIGCCFolder) + ASMIncludeLocation + '*.*', atAll);
				for J := 0 to Count - 1 do
					CopyFile (PChar (Items[J].FullName), PChar (Temp + ExtractFileName (Items[J].FullName)), False);
			finally
				Free;
			end;
		for I := 0 to Count - 1 do begin
			if Items [I] is THeaderSourceFile then begin
				with Items [I] as THeaderSourceFile do begin
					if Invalidated then
						RecompileFiles;
					if InProject then
						SplitAndWriteToFile (Temp + ExtractFileName (FileName));
				end;
			end else if Items [I] is TOtherSourceFile then
				with Items [I] as TSourceFile do
					if InProject then
						WriteToFile (Temp + ExtractFileName (FileName));
		end;
	end;
end;

procedure TMainForm.DeleteHeaders;
var
	I: Integer;
begin
	with TFileReferences.Create do try
		SearchForFiles (Temp + '*.h', atAll);
		for I := 0 to Count - 1 do try
			DeleteFile (Items[I].FullName);
		except end;
	finally
		Free;
	end;
	with SourceFiles do
		for I := 0 to Count - 1 do
			if (Items [I] is THeaderSourceFile) or (Items [I] is TOtherSourceFile) then
				with Items [I] as TSourceFile do begin
					if FileExists (Temp + ExtractFileName (FileName)) then try
						DeleteFile (Temp + ExtractFileName (FileName));
					except end;
				end;
end;

procedure TMainForm.TreeItemCompile(Sender: TObject);
begin
	if (not Compiling) and Assigned (ProjectTree.Selected) and Assigned (ProjectTree.Selected.Data) and (TSourceFile(ProjectTree.Selected.Data).Compilable) then begin
		BeginCompilation;
		CopyHeaders;
		TSourceFile(ProjectTree.Selected.Data).Compile;
		DeleteHeaders;
		EndCompilation;
	end;
end;

procedure TMainForm.CloseErrorsButtonClick(Sender: TObject);
begin
	HideErrors;
end;

procedure TMainForm.AddError(const Line: string; BugTp: TBugType; SourceF: string; ErrFunc: string; ErrMessage: string; SourceLn: Integer; Offset: Integer);
var
	I,
	J: Integer;
	O: TFoundError;
	Ignore: Boolean;
	Token: string;
begin
	ErrMessage := Trim (ErrMessage);
	if ErrMessage <> '' then begin
		Ignore := False;
		if BugTp in [btWarning, btInfo] then begin
			if ((ErrFunc = '') and (UpperCase (ErrMessage) = '''STATIC'' IS NOT AT BEGINNING OF DECLARATION'))
				or (Pos ('__DUMMY__', UpperCase (ErrMessage)) > 0)
				or (Pos ('''__R''', UpperCase (ErrMessage)) > 0)
				or (Pos ('MULTI-LINE STRING LITERALS ARE DEPRECATED', UpperCase (ErrMessage)) > 0) then
				Ignore := True;
		end else begin
			if (Pos ('(EACH UNDECLARED IDENTIFIER IS REPORTED ONLY ONCE', UpperCase (ErrMessage)) > 0)
				or (Pos ('FOR EACH FUNCTION IT APPEARS IN.)', UpperCase (ErrMessage)) > 0) then
				Ignore := True;
		end;
		if not Ignore then begin
			if ErrFunc = '__main' then
				ErrFunc := '_main';
			if ErrFunc = '__exit' then
				ErrFunc := '_exit';
			ErrorList.Items.BeginUpdate;
			try
				ErrMessage [1] := UpCase (ErrMessage [1]);
				O := TFoundError.Create;
				with O do begin
					SourceFile := nil;
					if (Length (SourceF) > 0) and (LowerCase (ExtractFileExt (SourceF)) <> '.exe') then begin
						if Pos ('\', SourceF) > 0 then
							SourceFile := SourceFiles.FindFile (SourceF)
						else
							SourceFile := SourceFiles.FindFileNameOnly (SourceF);
						if not Assigned (SourceFile) then begin
							if (Pos ('\', SourceF) > 0) and FileExists (SourceF) then
								SourceFile := AddSourceFile (SourceF, True)
							else if FileExists (WithBackslash (TIGCCFolder) + CIncludeLocation + ExtractFileName (SourceF)) then
								SourceFile := AddSourceFile (WithBackslash (TIGCCFolder) + CIncludeLocation + ExtractFileName (SourceF), True)
							else if FileExists (WithBackslash (TIGCCFolder) + AsmIncludeLocation + ExtractFileName (SourceF)) then
								SourceFile := AddSourceFile (WithBackslash (TIGCCFolder) + AsmIncludeLocation + ExtractFileName (SourceF), True);
						end;
					end;
					BugType := BugTp;
					WholeLine := Line;
					ErrorMessage := ErrMessage;
					ErrFunction := ErrFunc;
					if Assigned (SourceFile) and (SourceFile is TTextSourceFile) then
						with SourceFile as TTextSourceFile do
							if Assigned (TextEditor) then begin
								I := GetCompiledLineStart (SourceLn) + Offset;
								if I > 0 then begin
									if Pos ('''', ErrorMessage) > 0 then begin
										Token := Copy (ErrorMessage, Pos ('''', ErrorMessage) + 1, Length (ErrorMessage));
										Delete (Token, Pos ('''', Token), Length (Token));
										if Length (Token) > 0 then begin
											J := I;
											while (J <= TextEditor.TextLength) and (TextEditor.Text [J] in [#9, #10, #13, #32]) and (Copy (TextEditor.Text, J, Length (Token)) <> Token) do
												Inc (J);
											if Copy (TextEditor.Text, J, Length (Token)) = Token then
												I := J;
										end;
									end;
									O.Range := TMCRange.Create (TextEditor.TrackedRanges);
									O.Range.RStart := I;
									O.Range.OnOverwrite := DeleteError;
								end else
									O.Range := nil;
							end;
				end;
				with ErrorList.Items.Add do begin
					Data := Pointer (O);
					ImageIndex := Integer (BugTp);
					Caption := ErrMessage;
					if Assigned (O.SourceFile) then
						SubItems.Add (O.SourceFile.SourceName)
					else
						SubItems.Add ('');
					SubItems.Add (ErrFunc);
				end;
				ShowErrors;
			except end;
			ErrorList.Items.EndUpdate;
		end;
	end;
	UpdateErrorWindow;
end;

procedure TMainForm.ClearErrors;
begin
	HideErrors;
	with ErrorList.Items do begin
		BeginUpdate;
		Clear;
		EndUpdate;
	end;
	ActionProjectShowErrors.Enabled := False;
end;

procedure TMainForm.HideErrors;
begin
	Splitter2.Hide;
	ErrWinPanel.Hide;
	ActionProjectShowErrors.Checked := False;
end;

procedure TMainForm.ShowErrors;
begin
	if ErrorList.Items.Count > 0 then begin
		ErrWinPanel.Show;
		Splitter2.Show;
		Splitter2.Top := ErrWinPanel.Top - Splitter2.Height;
		ActionProjectShowErrors.Checked := True;
		ErrorList.Refresh;
	end;
end;

procedure TMainForm.ErrorListDeletion(Sender: TObject; Item: TListItem);
var
	O: TObject;
begin
	if Assigned (Item.Data) then begin
		O := TObject(Item.Data);
		Item.Data := nil;
		O.Free;
	end;
end;

procedure TMainForm.UpdateErrorWindow;
var
	I: Integer;
	EC,
	WC: Integer;
begin
	with ErrorList, Items do begin
		EC := 0;
		WC := 0;
		for I := 0 to Count - 1 do
			with TFoundError (Item[I].Data) do
				case BugType of
					btWarning:
						Inc (WC);
					btError:
						Inc (EC);
				end;
		ErrorsLabel.Caption := IntToStr (EC);
		WarningsLabel.Caption := IntToStr (WC);
		if Count <= 0 then
			HideErrors;
	end;
	ActionProjectShowErrors.Enabled := ErrorList.Items.Count > 0;
	if not ActionProjectShowErrors.Enabled then
		ActionProjectShowErrors.Checked := False;
end;

procedure TMainForm.TreeItemSave(Sender: TObject);
begin
	if Assigned (ProjectTree.Selected) and Assigned (ProjectTree.Selected.Data) then
		TSourceFile(ProjectTree.Selected.Data).Save;
end;

procedure TMainForm.HelpDocumentation(Sender: TObject);
begin
	try
		DocFile.Display;
	except
		ShowDefaultMessageBox ('Error opening documentation.', 'Error', mtProgramError);
	end;
end;

procedure TMainForm.EditorEnter(Sender: TObject);
begin
	ActionEditPaste.Enabled := True;
	ActionEditSelectAll.Enabled := True;
	ActionEditIncreaseIndent.Enabled := True;
	ActionEditDecreaseIndent.Enabled := True;
	ActionFindOpenFile.Enabled := True;
	UpdateEditButtons;
end;

procedure TMainForm.EditorExit(Sender: TObject);
begin
	ActionEditDelete.Enabled := False;
	ActionEditCut.Enabled := False;
	ActionEditCopy.Enabled := False;
	ActionEditPaste.Enabled := False;
	ActionEditSelectAll.Enabled := False;
	ActionEditIncreaseIndent.Enabled := False;
	ActionEditDecreaseIndent.Enabled := False;
	ActionFindOpenFile.Enabled := False;
	ActionEditUndo.Enabled := False;
	ActionEditRedo.Enabled := False;
end;

procedure TMainForm.EditUndo(Sender: TObject);
begin
	if Assigned (CurrentEditor) then
		CurrentEditor.Undo;
end;

procedure TMainForm.EditRedo(Sender: TObject);
begin
	if Assigned (CurrentEditor) then
		CurrentEditor.Redo;
end;

procedure TMainForm.EditClear(Sender: TObject);
var
	Editor: TMemoComponent;
begin
	Editor := CurrentEditor;
	if Assigned (Editor) and (ActiveControl = Editor) then
		Editor.ClearSelection
	else if ActiveControl = ProjectTree then
		TreeItemRemove (Sender);
end;

procedure TMainForm.EditCut(Sender: TObject);
var
	Editor: TMemoComponent;
begin
	Editor := CurrentEditor;
	if Assigned (Editor) and (ActiveControl = Editor) then
		Editor.CutToClipboard;
end;

procedure TMainForm.EditCopy(Sender: TObject);
var
	Editor: TMemoComponent;
begin
	Editor := CurrentEditor;
	if Assigned (Editor) and (ActiveControl = Editor) then
		Editor.CopyToClipboard;
end;

procedure TMainForm.EditPaste(Sender: TObject);
var
	Editor: TMemoComponent;
begin
	Editor := CurrentEditor;
	if Assigned (Editor) and (ActiveControl = Editor) then
		Editor.PasteFromClipboard;
end;

procedure TMainForm.EditSelectAll(Sender: TObject);
var
	Editor: TMemoComponent;
begin
	Editor := CurrentEditor;
	if Assigned (Editor) and (ActiveControl = Editor) then
		Editor.SelectAll;
end;

procedure TMainForm.ProjectCompile(Sender: TObject);
var
	I: Integer;
begin
	if not Compiling then begin
		if AutoSave then
			FileSave
		else
			with SourceFiles do
				for I := 0 to Count - 1 do
					with Items [I] as TSourceFile do
						if not InProject then
							Save;
		BeginCompilation;
		CompileProject;
		EndCompilation;
	end;
end;

procedure TMainForm.ProjectMake(Sender: TObject);
begin
	MakeFileWrapped;
	DisplayFolderMessage;
end;

procedure TMainForm.MakeFileWrapped;
var
	I: Integer;
begin
	if not Compiling then begin
		if AutoSave then
			FileSave
		else
			with SourceFiles do
				for I := 0 to Count - 1 do
					with Items [I] as TSourceFile do
						if not InProject then
							Save;
		OperationSuccessful := False;
		if ProjectFile = '' then
			ShowDefaultMessageBox ('You need to save your project before you can create executable files.', 'Project not Saved', mtProgramError)
		else begin
			BeginCompilation;
			CompileProject;
			Application.ProcessMessages;
			if OperationSuccessful and not OperationCancelled then
				MakeFile;
			EndCompilation;
		end;
	end;
end;

procedure TMainForm.MakeFile;
	var
		HadErrors: Boolean;
		VarName: array [0..255] of Char;
	procedure ProcessErrorLine(Line: string);
	var
		Whole,
		FileName: string;
		P: Integer;
		Tp: TBugType;
	begin
		P := Pos (#10, Line);
		if P > 0 then begin
			ProcessErrorLine (Copy (Line, 1, P - 1));
			ProcessErrorLine (Copy (Line, P + 1, Length (Line)));
		end else begin
			repeat
				P := Pos ('`', Line);
				if P > 0 then
					Line [P] := '''';
			until P <= 0;
			Whole := Line;
			if (Pos ('FIRST DEFINED HERE', UpperCase (Line)) <= 0) and (not (HadErrors and (Pos ('IMPORTS ARE NOT ALLOWED', UpperCase (Line)) > 0))) then begin
				FileName := '';
				if Copy (Line, 1, 3) = 'LD:' then begin
					Delete (Line, 1, 3);
					Line := Trim (Line);
					if Pos (':', Line) > 0 then begin
						FileName := Copy (Line, 1, Pos (':', Line) - 1);
						Delete (Line, 1, Pos (':', Line));
					end;
				end;
				if Pos (' NEEDED BY', UpperCase (Line)) > 0 then
					Delete (Line, Pos (' NEEDED BY', UpperCase (Line)), Length (Line));
				if StartsWith ('WARNING: ', Line, False, True) or StartsWith ('WARNING : ', Line, False, True) then
					Tp := btWarning
				else begin
					StartsWith ('ERROR: ', Line, False, True);
					StartsWith ('ERROR : ', Line, False, True);
					Tp := btError;
					if Length (Trim (Line)) > 0 then
						OperationSuccessful := False;
				end;
				Line := Trim (Line);
				if Length (Line) > 0 then begin
					if (Line [1] in ['0', '2'..'9']) or ((Length (Line) > 1) and (Line [2] = '1')) then begin
						P := Pos ('(s)', Line);
						if P > 0 then begin
							Delete (Line, P + 2, 1);
							Delete (Line, P, 1);
						end;
					end else if Line [1] = '1' then begin
						P := Pos ('(s)', Line);
						if P > 0 then
							Delete (Line, P, 3);
					end;
					AddError (Whole, Tp, FileName, '', Line, 0, 0);
					HadErrors := True;
				end;
			end;
		end;
	end;
	procedure FileNotCompiled(const FileName: string);
	begin
		ShowDefaultMessageBox
			('The file ''' + FileName + ''' has not been compiled.  You have to compile it first before you can link it to your project.',
			'No Object File', mtProgramError);
	end;
	procedure RunCompressor(const CommandLine: string);
	begin
		CompUpdate;
		MainConsole.Title := 'Compressor';
		try
			MainConsole.StartProcess ('', CommandLine, WithoutBackslash (Temp));
			WaitForMainConsole ('Compressing');
		except
			ShowDefaultMessageBox ('Could not start compressing program.', 'Error', mtProgramError);
			OperationCancelled := True;
		end;
		UpdateProgramOutput;
	end;
	procedure PackFile(const SourceFile: string; const DestFile: string; const PackVar: string; CalcDests: TCalcDests);
	var
		InputStream,
		OutputStream: TMemoryStream;
		OutputSize: LongWord;
	begin
		CompStartFile;
		CompSetMessage ('Compressing File ''' + WithoutExt (ExtractFileName (ProjectFile)) + '''');
		OperationSuccessful := False;
		if FileExists (ChangeFileExt (DestFile, '.89y')) then try
			DeleteFile (ChangeFileExt (DestFile, '.89y'));
		except end;
		if FileExists (ChangeFileExt (DestFile, '.9xy')) then try
			DeleteFile (ChangeFileExt (DestFile, '.9xy'));
		except end;
		if not OperationCancelled then begin
			if FileExists (WithBackslash (TIGCCFolder) + PackLocation + 'Pack.exe') then
				RunCompressor ('"' + WithBackslash (TIGCCFolder) + PackLocation + 'Pack.exe" "' + SourceFile + '" tempprog.pck')
			else begin
				ShowDefaultMessageBox ('Cannot find compression tool ''Pack''.', 'Error', mtProgramError);
				OperationCancelled := True;
			end;
		end;
		if not OperationCancelled then begin
			if FileExists (Temp + 'tempprog.pck') then begin
				InputStream := TMemoryStream.Create;
				with InputStream do try
					LoadFromFile (Temp + 'tempprog.pck');
					OutputSize := GetTransferFileSize (Size, 'ppg');
					if OutputSize > 0 then begin
						OutputStream := TMemoryStream.Create;
						try
							OutputStream.Size := OutputSize;
							if cdTI89 in CalcDests then begin
								ProduceTransferFile (OutputStream.Memory, Memory, Size, cdTI89, 'main', PackVar, $1C, $F8, 'ppg');
								OutputStream.SaveToFile (ChangeFileExt (DestFile, '.89y'));
							end;
							if cdTI92Plus in CalcDests then begin
								ProduceTransferFile (OutputStream.Memory, Memory, Size, cdTI92Plus, 'main', PackVar, $1C, $F8, 'ppg');
								OutputStream.SaveToFile (ChangeFileExt (DestFile, '.9xy'));
							end;
							OperationSuccessful := True;
						finally
							OutputStream.Free;
						end;
					end else begin
						ShowDefaultMessageBox ('Compressed size of ' + IntToStr (Size) + ' bytes is too large, unexpectedly.', 'Error', mtProgramError);
						OperationCancelled := True;
					end;
				finally
					Free;
				end;
			end else begin
				ShowDefaultMessageBox ('Compression failed. Please check the program size.', 'Error', mtProgramError);
				OperationCancelled := True;
			end;
		end;
	end;
	procedure CreatePackStarter(const DestProject: string; const PackVar: string; CalcDests: TCalcDests);
	begin
		CompUpdate;
		OperationSuccessful := False;
		if FileExists (ChangeFileExt (DestProject, '.89z')) then try
			DeleteFile (ChangeFileExt (DestProject, '.89z'));
		except end;
		if FileExists (ChangeFileExt (DestProject, '.9xz')) then try
			DeleteFile (ChangeFileExt (DestProject, '.9xz'));
		except end;
		if FileExists (WithBackslash (TIGCCFolder) + PStarterLocation + 'PStarter.o') then try
			ParsePStarter (WithBackslash (TIGCCFolder) + PStarterLocation + 'PStarter.o', Temp + VarName + '.o', PackVar);
		except
			ShowDefaultMessageBox ('Error processing starter object file.', 'Error', mtProgramError);
			OperationCancelled := True;
		end else begin
			ShowDefaultMessageBox ('Cannot find starter object file.', 'Error', mtProgramError);
			OperationCancelled := True;
		end;
		if (not OperationCancelled) and FileExists (WithBackslash (TIGCCFolder) + LinkLocation + 'Obj2TI.exe') then
			RunCompressor ('"' + WithBackslash (TIGCCFolder) + LinkLocation + 'Obj2TI.exe" ' + DefaultLinkSwitches + ' ' + LinkSwitches + ' ' + VarName + '.o')
		else begin
			ShowDefaultMessageBox ('Cannot find linker.', 'Error', mtProgramError);
			OperationCancelled := True;
		end;
		if (cdTI89 in CalcDests) and FileExists (Temp + VarName + '.89z') then try
			CopyFile (PChar (Temp + VarName + '.89z'), PChar (ChangeFileExt (DestProject, '.89z')), False);
			OperationSuccessful := True;
		except end;
		if (cdTI92Plus in CalcDests) and FileExists (Temp + VarName + '.9xz') then try
			CopyFile (PChar (Temp + VarName + '.9xz'), PChar (ChangeFileExt (DestProject, '.9xz')), False);
			OperationSuccessful := True;
		except end;
		if FileExists (Temp + VarName + '.89z') then try
			DeleteFile (Temp + VarName + '.89z');
		except end;
		if FileExists (Temp + VarName + '.9xz') then try
			DeleteFile (Temp + VarName + '.9xz');
		except end;
		if (not OperationSuccessful) and (not OperationCancelled) then
			AddError ('Error compressing file', btError, '', '', 'Error compressing file', 0, 0);
	end;
	function GetPrimaryFile: TSourceFile;
	var
		I,
		J: Integer;
	begin
		Result := nil;
		with TopNode do
			for I := 0 to Count - 1 do
				with Item [I] do
					for J := 0 to Count - 1 do
						if Assigned (Item[J].Data) then
							with TSourceFile (Item[J].Data) do
								if InProject and Compilable then begin
									Result := TSourceFile (Item[J].Data);
									Exit;
								end;
	end;
var
	CurSection,
	I,
	J,
	P: Integer;
	C: Cardinal;
	F: System.Text;
	L: TStringList;
	LF: file;
	Bt: Byte;
	S1,
	S2,
	SpecialLinkSwitches,
	ObjectFileNames,
	ArchiveFileNames: string;
	ObjectFileCount,
	ArchiveFileCount: Integer;
	CalcDests: TCalcDests;
	COFFStream: TFileStream;
	COFFHeaders: TCOFFHeaders;
	COFFLines: TCOFFLines;
	InputStream,
	OutputStream: TMemoryStream;
	OutputSize: LongWord;
begin
	UpdateErrorWindow;
	OperationCancelled := False;
	OperationSuccessful := False;
	ProgSize := 0;
	HadErrors := False;
	if FileExists (Temp + VarName + '.89Z') then
		DeleteFile (Temp + VarName + '.89Z');
	if FileExists (Temp + VarName + '.9XZ') then
		DeleteFile (Temp + VarName + '.9XZ');
	if FileExists (Temp + 'TEMPAR.A') then
		DeleteFile (Temp + 'TEMPAR.A');
	OperationSuccessful := True;
	CalcDests := [];
	with TopNode do begin
		StrPLCopy (VarName, LowerCase (Text), 255);
		CharLower (VarName);
		for I := 0 to Count - 1 do
			with Item [I] do
				for J := 0 to Count - 1 do
					if Assigned (Item[J].Data) then
						with TSourceFile (Item[J].Data) do
							if InProject and Compilable and (not FileExists (ChangeFileExt (FileName, '.o'))) then begin
								OperationSuccessful := False;
								FileNotCompiled (SourceName);
							end;
	end;
	if OperationSuccessful then begin
		OperationSuccessful := False;
		if FileExists (WithBackslash (TIGCCFolder) + LinkLocation + 'Obj2TI.exe') and FileExists (WithBackslash (TIGCCFolder) + LdLocation + 'Ld.exe') then begin
			CompStartFile;
			CompSetMessage ('Linking Project ''' + WithoutExt (ExtractFileName (ProjectFile)) + '''');
			ObjectFileCount := 0;
			ObjectFileNames := '';
			ArchiveFileCount := 0;
			ArchiveFileNames := '';
			with TopNode do
				for I := 0 to Count - 1 do
					with Item [I] do
						for J := 0 to Count - 1 do
							if Assigned (Item[J].Data) then
								with TSourceFile (Item[J].Data) do
									if InProject then begin
										if TSourceFile (Item[J].Data) is TArchiveSourceFile then begin
											Inc (ArchiveFileCount);
											Insert (' ar' + IntToStr (ArchiveFileCount) + '.a', ArchiveFileNames, Length (ArchiveFileNames) + 1);
											CopyFile (PChar (FileName), PChar (Temp + 'AR' + IntToStr (ArchiveFileCount) + '.A'), False)
										end else if Compilable or (TSourceFile (Item[J].Data) is TObjectSourceFile) then begin
											Inc (ObjectFileCount);
											Insert (' fl' + IntToStr (ObjectFileCount) + '.o', ObjectFileNames, Length (ObjectFileNames) + 1);
											CopyFile (PChar (ChangeFileExt (FileName, '.o')), PChar (Temp + 'FL' + IntToStr (ObjectFileCount) + '.O'), False);
										end;
									end;
			if StdLib and FileExists (WithBackslash (TIGCCFolder) + StdLibLocation + 'TIGCC.A') then begin
				Inc (ArchiveFileCount);
				Insert (' ar' + IntToStr (ArchiveFileCount) + '.a', ArchiveFileNames, Length (ArchiveFileNames) + 1);
				CopyFile (PChar (WithBackslash (TIGCCFolder) + StdLibLocation + 'TIGCC.A'), PChar (Temp + 'AR' + IntToStr (ArchiveFileCount) + '.A'), False);
			end;
			MainConsole.Title := 'Linker';
			try
				if ProjectTarget = ptArchive then
					MainConsole.StartProcess (WithBackslash (TIGCCFolder) + ArLocation + 'Ar.exe', DefaultArSwitches + ' TEMPAR.A ' + ObjectFileNames, WithoutBackslash (Temp))
				else
					MainConsole.StartProcess (WithBackslash (TIGCCFolder) + LdLocation + 'Ld.exe', DefaultLdSwitches + ' ' + LdSwitches + ' ' + ObjectFileNames + ' ' + ArchiveFileNames + ' -o ' + UpperCase (VarName) + '.O', WithoutBackslash (Temp));
				WaitForMainConsole ('Linking');
			except
				ShowDefaultMessageBox ('Could not start linker.', 'Error', mtProgramError);
			end;
			UpdateProgramOutput;
			if not OperationCancelled then try
				with TStringList.Create do try
					Text := MainConsole.LastErrText;
					if Count > 0 then begin
						ErrorList.Items.BeginUpdate;
						try
							for I := 0 to Count - 1 do
								if Length (Strings [I]) > 0 then
									ProcessErrorLine ('LD:' + Copy (Strings [I], Pos (':', Strings [I]) + 1, Length (Strings [I])));
						finally
							ErrorList.Items.EndUpdate;
						end;
					end;
				finally
					Free;
				end;
			except end;
			if ProjectTarget = ptArchive then
				OperationSuccessful := FileExists (Temp + 'TEMPAR.A')
			else begin
				OperationSuccessful := FileExists (Temp + VarName + '.O');
				if OperationSuccessful and DebugInfo then begin
					COFFStream := TFileStream.Create (Temp + VarName + '.O', fmOpenRead or fmShareDenyWrite);
					try
						ReadCOFFHeaders (COFFStream, COFFHeaders);
						ReadCOFFSymbols (COFFStream, COFFHeaders.FileHeader, CurrentSymbols);
						if Assigned (CurrentStrings) then
							CurrentStrings.Clear
						else
							CurrentStrings := TMemoryStream.Create;
						ReadCOFFStrings (COFFStream, COFFHeaders.FileHeader, CurrentStrings);
						with COFFHeaders do
							for CurSection := Low (SectionHeaders) to High (SectionHeaders) do
								with SectionHeaders [CurSection] do
									if ReadCalcInt (LineCount) > 0 then begin
										ReadCOFFLines (COFFStream, SectionHeaders [CurSection], COFFLines);
										with TopNode do
											for I := 0 to Count - 1 do
												with Item [I] do
													for J := 0 to Count - 1 do
														if Assigned (Item[J].Data) then
															if (TSourceFile(Item[J].Data) is TCSourceFile) or (TSourceFile(Item[J].Data) is TQuillSourceFile) then
																with TSourceFile (Item[J].Data) as TSourceTextSourceFile do
																	if InProject and FileExists (ChangeFileExt (FileName, '.s')) then begin
																		L := TStringList.Create;
																		with L do try
																			LoadFromFile (ChangeFileExt (FileName, '.s'));
																			ParseCOFFDebugSFile (L, SectionHeaders [CurSection], FileName, CurrentSymbols, CurrentStrings, COFFLines, CurrentLineInfo);
																			SaveToFile (ChangeFileExt (FileName, '.s'));
																		finally
																			Free;
																		end;
																	end;
										Break;
									end;
					finally
						COFFStream.Free;
					end;
				end;
			end;
			if OperationSuccessful then begin
				OperationSuccessful := False;
				if ProjectTarget = ptArchive then begin
					if FileExists (Temp + 'TEMPAR.A') then begin
						AssignFile (LF, Temp + 'TEMPAR.A');
						Reset (LF, 1);
						ProgSize := FileSize (LF);
						CloseFile (LF);
						if not OperationCancelled then begin
							CopyFile (PChar (Temp + 'TEMPAR.A'), PChar (ChangeFileExt (ProjectFile, '.a')), False);
							OperationSuccessful := True;
						end;
						DeleteFile (Temp + 'TEMPAR.A');
					end else
						ProgSize := 0;
				end else begin
					if Pack and (ssPack in SpecialSupport) then
						SpecialLinkSwitches := '--outputbin'
					else
						SpecialLinkSwitches := '';
					CompUpdate;
					try
						MainConsole.StartProcess (WithBackslash (TIGCCFolder) + LinkLocation + 'Obj2TI.exe', DefaultLinkSwitches + ' ' + LinkSwitches + ' ' + SpecialLinkSwitches + ' ' + VarName + '.O', WithoutBackslash (Temp));
						WaitForMainConsole ('Linking');
					except
						ShowDefaultMessageBox ('Could not start linker.', 'Error', mtProgramError);
					end;
					UpdateProgramOutput;
					if not OperationCancelled then try
						S1 := MainConsole.LastOutText;
						if Pack and (ssPack in SpecialSupport) and (Length (S1) <= 0) then
							CalcDests := [cdTI89, cdTI92Plus]
						else begin
							if Pos ('LINKED FOR TI-89', UpperCase (S1)) > 0 then
								Include (CalcDests, cdTI89);
							if Pos ('LINKED FOR TI-92 PLUS', UpperCase (S1)) > 0 then
								Include (CalcDests, cdTI92Plus);
						end;
						if (Pos ('SIZE', UpperCase (S1)) > 0) or (Pos ('BYTES (', UpperCase (S1)) > 0) then begin
							if Pos ('SIZE', UpperCase (S1)) > 0 then
								Delete (S1, 1, Pos ('SIZE', UpperCase (S1)) + Length ('SIZE') - 1)
							else
								Delete (S1, 1, Pos ('BYTES (', UpperCase (S1)) + Length ('BYTES (') - 1);
							while (Length (S1) > 0) and not (S1 [1] in ['0'..'9']) do
								Delete (S1, 1, 1);
							S2 := '';
							while (Length (S1) > 0) and (S1 [1] in ['0'..'9']) do begin
								Insert (S1 [1], S2, Length (S2) + 1);
								Delete (S1, 1, 1);
							end;
							ProgSize := StrToInt (S2);
						end;
						with TStringList.Create do try
							Text := MainConsole.LastErrText;
							if Count > 0 then begin
								ErrorList.Items.BeginUpdate;
								try
									for I := 0 to Count - 1 do
										if Copy (Strings [I], 1, Length ('--==<')) <> '--==<' then
											ProcessErrorLine (Strings [I]);
								finally
									ErrorList.Items.EndUpdate;
								end;
							end;
						finally
							Free;
						end;
					except end;
					if FileExists (Temp + VarName + '.89Z') then begin
						if not OperationCancelled then begin
							CopyFile (PChar (Temp + VarName + '.89Z'), PChar (ChangeFileExt (ProjectFile, '.89z')), False);
							OperationSuccessful := True;
							Include (CalcDests, cdTI89);
						end;
						DeleteFile (Temp + VarName + '.89Z');
					end;
					if FileExists (Temp + VarName + '.9XZ') then begin
						if not OperationCancelled then begin
							CopyFile (PChar (Temp + VarName + '.9XZ'), PChar (ChangeFileExt (ProjectFile, '.9xz')), False);
							OperationSuccessful := True;
							Include (CalcDests, cdTI92Plus);
						end;
						DeleteFile (Temp + VarName + '.9XZ');
					end;
					if FileExists (Temp + VarName + '.BIN') then begin
						if not OperationCancelled then begin
							if Pack and (ssPack in SpecialSupport) then begin
								PackFile (Temp + VarName + '.BIN', ProjectFile, PackVar, CalcDests);
								if OperationSuccessful and (not OperationCancelled) then
									CreatePackStarter (ProjectFile, PackVar, CalcDests);
							end else begin
								CopyFile (PChar (Temp + VarName + '.BIN'), PChar (ChangeFileExt (ProjectFile, '.bin')), False);
								OperationSuccessful := True;
							end;
						end;
						DeleteFile (Temp + VarName + '.BIN');
					end;
					if FileExists (Temp + VarName + '.HEX') then begin
						if not OperationCancelled then begin
							CopyFile (PChar (Temp + VarName + '.HEX'), PChar (ChangeFileExt (ProjectFile, '.hex')), False);
							OperationSuccessful := True;
						end;
						DeleteFile (Temp + VarName + '.HEX');
					end;
					if FileExists (Temp + VarName + '.SYM') then begin
						if not OperationCancelled then begin
							CopyFile (PChar (Temp + VarName + '.SYM'), PChar (ChangeFileExt (ProjectFile, '.sym')), False);
							OperationSuccessful := True;
						end;
						DeleteFile (Temp + VarName + '.SYM');
					end;
					if FileExists (Temp + VarName + '.NDL') then begin
						if not OperationCancelled then begin
							InputStream := TMemoryStream.Create;
							with InputStream do try
								LoadFromFile (Temp + VarName + '.NDL');
								OutputSize := GetTransferFileSize (Size, 'DLL');
								if OutputSize > 0 then begin
									OutputStream := TMemoryStream.Create;
									try
										OutputStream.Size := OutputSize;
										if cdTI89 in CalcDests then begin
											ProduceTransferFile (OutputStream.Memory, Memory, Size, cdTI89, 'main', VarName, $1C, $F8, 'DLL');
											OutputStream.SaveToFile (ChangeFileExt (ProjectFile, '.89y'));
										end;
										if cdTI92Plus in CalcDests then begin
											ProduceTransferFile (OutputStream.Memory, Memory, Size, cdTI92Plus, 'main', VarName, $1C, $F8, 'DLL');
											OutputStream.SaveToFile (ChangeFileExt (ProjectFile, '.9xy'));
										end;
										OperationSuccessful := True;
									finally
										OutputStream.Free;
									end;
								end else begin
									ShowDefaultMessageBox ('DLL size of ' + IntToStr (Size) + ' bytes is too large.', 'Error', mtProgramError);
									OperationCancelled := True;
								end;
							finally
								Free;
							end;
						end;
						DeleteFile (Temp + VarName + '.NDL');
					end;
					if Length (PostBuildProcessFile) > 0 then begin
						CompStartFile;
						CompSetMessage ('Calling User-Defined Program');
						MainConsole.Title := 'User-Defined Program';
						S1 := PostBuildProcessFile;
						P := Pos ('($TI89FILE)', UpperCase (S1));
						if P > 0 then begin
							Delete (S1, P, Length ('($TI89FILE)'));
							if cdTI89 in CalcDests then
								Insert (ChangeFileExt (ProjectFile, '.89z'), S1, P);
						end;
						P := Pos ('($TI92PLUSFILE)', UpperCase (S1));
						if P > 0 then begin
							Delete (S1, P, Length ('($TI92PLUSFILE)'));
							if cdTI92Plus in CalcDests then
								Insert (ChangeFileExt (ProjectFile, '.9xz'), S1, P);
						end;
						try
							MainConsole.StartProcess ('', S1, '');
							WaitForMainConsole ('User-Defined');
						except
							ShowDefaultMessageBox ('Could not start the user-defined program.', 'Error', mtProgramError);
							OperationSuccessful := False;
						end;
						UpdateProgramOutput;
					end;
				end;
			end;
			if not OperationSuccessful then
				ProgSize := 0;
			CompUpdate;
			try
				if FileExists (Temp + 'LINK.BAT') then
					DeleteFile (Temp + 'LINK.BAT');
				if FileExists (Temp + 'OUTPUT.DMP') then
					DeleteFile (Temp + 'OUTPUT.DMP');
				if FileExists (Temp + 'TEMPPROG.PCK') then
					DeleteFile (Temp + 'TEMPPROG.PCK');
				if FileExists (Temp + 'TEMPPROG.S') then
					DeleteFile (Temp + 'TEMPPROG.S');
				if FileExists (Temp + VarName + '.O') then
					DeleteFile (Temp + VarName + '.O');
				for I := 1 to ObjectFileCount do
					DeleteFile (Temp + 'FL' + IntToStr (I) + '.O');
				for I := 1 to ArchiveFileCount do
					DeleteFile (Temp + 'AR' + IntToStr (I) + '.A');
				if OperationSuccessful and DeleteAssemblyFiles and (not DebugInfo) then
					with TopNode do
						for I := 0 to Count - 1 do
							with Item [I] do
								for J := 0 to Count - 1 do
									if Assigned (Item[J].Data) then
										with TSourceFile (Item[J].Data) do
											if InProject and (TSourceFile(Item[J].Data) is TCSourceFile) then
												if FileExists (ChangeFileExt (FileName, '.s')) then
													DeleteFile (ChangeFileExt (FileName, '.s'));
				if OperationSuccessful and DeleteObjectFiles then
					with TopNode do
						for I := 0 to Count - 1 do
							with Item [I] do
								for J := 0 to Count - 1 do
									if Assigned (Item[J].Data) then
										with TSourceFile (Item[J].Data) do
											if InProject and Compilable then begin
												Invalidate;
												if FileExists (ChangeFileExt (FileName, '.o')) then
													DeleteFile (ChangeFileExt (FileName, '.o'));
											end;
			except end;
			UpdateErrorWindow;
			ShowErrors;
			CompUpdate;
			if OperationSuccessful then begin
				Invalidated := False;
				CompUpdate;
			end;
		end else
			ShowDefaultMessageBox ('Cannot find linker.', 'Error', mtProgramError);
	end;
end;

procedure TMainForm.FileOpenProject(Sender: TObject);
begin
	if OpenProjectDlg.Execute then begin
		if LowerCase (ExtractFileExt (OpenProjectDlg.FileName)) = LowerCase (ProjectFileExt) then
			FileOpen (ExpandFileName (OpenProjectDlg.FileName))
		else
			AddSourceFile (OpenProjectDlg.FileName, True);
	end else
		Abort;
end;

procedure TMainForm.FileSaveAll(Sender: TObject);
begin
	FileSave;
end;

procedure TMainForm.FileSaveProjectAs(Sender: TObject);
begin
	SaveProjectDlg.FileName := ProjectFile;
	if SaveProjectDlg.Execute then
		FileSaveAs (ExpandFileName (SaveProjectDlg.FileName))
	else
		Abort;
end;

procedure TMainForm.EditorKeyDown(Sender: TObject; var Key: Word;
	Shift: TShiftState);
var
	I: Integer;
	S: string;
begin
	if Key = vk_F1 then
		if Sender is TMemoComponent then
			with Sender as TMemoComponent do begin
				S := '';
				for I := Selection.RStart - 1 downto 1 do begin
					if Text [I] in ['A'..'Z', 'a'..'z', '0'..'9', '_', '$', '#'] then
						S := Text [I] + S
					else
						Break;
				end;
				for I := Selection.RStart to TextLength do begin
					if Text [I] in ['A'..'Z', 'a'..'z', '0'..'9', '_', '$', '#'] then
						S := S + Text [I]
					else
						Break;
				end;
				if S <> '' then begin
					with SourceFiles do
						for I := 0 to Count - 1 do
							with Items [I] as TSourceFile do
								if Assigned (ParentForm) then
									ParentForm.WindowState := wsMinimized;
					Application.ProcessMessages;
					DocFile.KeywordLookup (S);
				end;
			end;
end;

procedure TMainForm.ProjectBuild(Sender: TObject);
var
	I: Integer;
begin
	if not Compiling then begin
		if AutoSave then
			FileSave
		else
			with SourceFiles do
				for I := 0 to Count - 1 do
					with Items [I] as TSourceFile do
						if not InProject then
							Save;
		OperationSuccessful := False;
		if ProjectFile = '' then
			ShowDefaultMessageBox ('You need to save your project before you can create executable files.', 'Project not Saved', mtProgramError)
		else begin
			BeginCompilation;
			RecompileFiles;
			CompileProject;
			Application.ProcessMessages;
			if OperationSuccessful and not OperationCancelled then
				MakeFile;
			EndCompilation;
			DisplayFolderMessage;
		end;
	end;
end;

procedure TMainForm.ProjectTreeKeyDown(Sender: TObject; var Key: Word;
	Shift: TShiftState);
begin
	if (Key = vk_Delete) and not ProjectTree.IsEditing then
		TreeItemRemove (Sender);
end;

procedure TMainForm.ProjectTreeMouseUp(Sender: TObject;
	Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
	if Button = mbRight then
		with ProjectTree do
			if Assigned (Selected) and Assigned (Selected.Data) then
				with TSourceFile (Selected.Data) do begin
					ActionTreeItemSave.Enabled := TSourceFile (Selected.Data) is TTextSourceFile;
					ActionTreeItemSaveAs.Enabled := True;
					ActionTreeItemCompile.Enabled := Compilable;
					with Mouse.CursorPos do
						ProjectTreePopup.Popup (X, Y);
				end;
end;

procedure TMainForm.ProjectTreeEdited(Sender: TObject; Node: TTreeNode;
	var S: String);
var
	I: Integer;
	NameConflict: Boolean;
begin
	if Node = TopNode then begin
		if Length (S) <= 0 then
			S := 'Project1'
		else begin
			for I := Length (S) downto 1 do
				if (not (IsCharAlphaNumeric (S [I]) or (S [I] in ['A'..'Z', 'a'..'z', '0'..'9', '_']))) or ((I = 1) and (S [I] = '_')) then
					Delete (S, I, 1);
			if Length (S) <= 0 then
				S := 'Project1'
			else if not (IsCharAlpha (S [1]) or (S [1] in ['A'..'Z', 'a'..'z'])) then
				S := 'X' + S;
		end;
		S := Copy (S, 1, 8);
		Modify;
	end else begin
		if S = '' then
			S := 'File1';
		NameConflict := False;
		if Assigned (Node.Data) and (TSourceFile(Node.Data).Compilable) then
			with SourceFiles do
				for I := 0 to Count - 1 do
					if Items [I] <> Node.Data then
						with Items [I] as TSourceFile do
							if Compilable and (LowerCase (SourceName) = LowerCase (S)) then begin
								NameConflict := True;
								Break;
							end;
		if NameConflict then begin
			S := Node.Text;
			ShowDefaultMessageBox ('The name you chose conflicts with that of another file.', 'Error', mtProgramError)
		end else begin
			if Assigned (Node.Data) then
				TSourceFile(Node.Data).SourceName := S;
			Modify;
		end;
	end;
end;

procedure TMainForm.SetProjectFile(const Value: string);
var
	S: string;
	B: Boolean;
begin
	FProjectFile := Value;
	MasterUnit.ProjectFileName := Value;
	if Value = '' then
		Caption := OriginalCaption
	else
		Caption := OriginalCaption + ' - ' + WithoutExt (ExtractFileName (Value));
	if TopNode.Text = 'Project1' then begin
		B := Modified;
		S := WithoutExt (ExtractFileName (Value));
		ProjectTreeEdited (ProjectTree, TopNode, S);
		TopNode.Text := S;
		Modified := B;
	end;
end;

function TMainForm.AddSourceFile(const FN: string; OpenOnly: Boolean = False; SourceFileClass: TSourceFileClass = nil): TSourceFile;
var
	N: TTreeNode;
	F: TForm;
	S: string;
	O: TOpenFileStatusForm;
begin
	if Compiling and (not OpenOnly) then
		Result := nil
	else begin
		Result := SourceFiles.FindFile (FN);
		if Assigned (Result) and Result.InProject then begin
			Result := nil;
			ShowDefaultMessageBox ('The file ''' + ExtractFileName (FN) + ''' is already included in the project.', 'File Already Included', mtProgramError);
		end else if OpenOnly and Assigned (Result) then begin
			Result := nil;
			ShowDefaultMessageBox ('The file ''' + ExtractFileName (FN) + ''' has already been opened.', 'File Already Opened', mtProgramError);
		end else if (not OpenOnly) and (LowerCase (ExtractFileExt (FN)) = '.qll') and (Assigned (SourceFiles.FindFileOfTypeInProject (TQuillSourceFile))) then begin
			Result := nil;
			ShowDefaultMessageBox ('There may be only one Quill source file in each project.', 'Quill Error', mtProgramError);
		end else begin
			if not Assigned (Result) then begin
				O := nil;
				try
					if not OpeningProjectNow then begin
						O := TOpenFileStatusForm.Create (Self);
						S := ExtractFileName (FN);
						O.FileNameLabel.Caption := 'Opening File ''' + Copy (S, 1, LastPos ('.', S) - 1) + '''...';
						O.Show;
						O.Update;
					end;
					if not Assigned (SourceFileClass) then
						SourceFileClass := TSourceFile.GetAppropriateClassFromExt (ExtractFileExt (FN));
					Result := SourceFileClass.Create (SourceFiles);
					Result.FileName := FN;
					Result.OnError := AddError;
				finally
					if Assigned (O) then
						O.Free;
				end;
				if OpenOnly and (not Assigned (Result.Editor)) then begin
					Result.Free;
					Result := nil;
					ShowDefaultMessageBox ('The file ''' + ExtractFileName (FN) + ''' is not a valid file for opening.', 'Invalid File', mtProgramError);
				end;
			end;
			if Assigned (Result) then
				with Result do begin
					ErrorList := Self.ErrorList;
					if OpenOnly then begin
						if not Assigned (ParentForm) then begin
							ParentForm := TSourceFileForm.Create (nil);
							with ParentForm as TSourceFileForm do begin
								Enabled := False;
								SourceFile := Result;
								Show;
							end;
							if Assigned (Editor) then
								with Editor do begin
									Parent := ParentForm;
									Align := alClient;
									Show;
									if Enabled then
										SetFocus;
								end;
						end;
					end else begin
						if Assigned (Editor) then
							Editor.Parent := nil;
						if Assigned (ParentForm) then begin
							F := ParentForm;
							ParentForm := nil;
							F.Free;
						end;
						N := ProjectTree.Items.AddChildObject (TopNode.Item [ClassTreeIndex], SourceName, Pointer (Result));
						with N do begin
							ImageIndex := ClassImageIndex;
							SelectedIndex := ImageIndex;
						end;
						TreeItem := N;
						if Assigned (Editor) then
							with Editor do begin
								Hide;
								Parent := EditorPanel;
								Align := alClient;
							end;
						if Result is TTextSourceFile then
							with Result as TTextSourceFile do
								if Assigned (TextEditor) then
									with TextEditor do begin
										OnEnter := EditorEnter;
										OnExit := EditorExit;
										OnKeyDown := EditorKeyDown;
										OnChange := EditorChange;
										OnSelectionChange := EditorChange;
										PopupMenu := EditorPopup;
									end;
					end;
				end;
		end;
		SortFiles;
	end;
end;

procedure TMainForm.ProjectOptions(Sender: TObject);
begin
	with TProjectOptionsForm.Create (Self) do try
		if ssAr in SpecialSupport then begin
			if ProjectTarget = ptArchive then
				ArchiveRadioButton.Checked := True
			else
				ExecutableRadioButton.Checked := True;
		end else
			ArchiveRadioButton.Enabled := False;
		PackCheckBox.Checked := Pack and (ssPack in SpecialSupport);
		PackVarEdit.Text := PackVar;
		GCCSwitchesEdit.Text := GCCSwitches;
		AsSwitchesEdit.Text := AsSwitches;
		AsmSwitchesEdit.Text := AsmSwitches;
		LdSwitchesEdit.Text := LdSwitches;
		LinkSwitchesEdit.Text := LinkSwitches;
		DebugInfoCheckBox.Checked := DebugInfo;
		StdLibCheckBox.Checked := StdLib;
		CommandLineEdit.Text := CommandLine;
		ProcessFileEdit.Text := PostBuildProcessFile;
		if ShowModal = mrOK then begin
			if ArchiveRadioButton.Checked then
				ProjectTarget := ptArchive
			else
				ProjectTarget := ptExecutable;
			Pack := PackCheckBox.Checked;
			PackVar := PackVarEdit.Text;
			GCCSwitches := GCCSwitchesEdit.Text;
			AsSwitches := AsSwitchesEdit.Text;
			AsmSwitches := AsmSwitchesEdit.Text;
			LdSwitches := LdSwitchesEdit.Text;
			LinkSwitches := LinkSwitchesEdit.Text;
			DebugInfo := DebugInfoCheckBox.Checked;
			StdLib := StdLibCheckBox.Checked;
			CommandLine := CommandLineEdit.Text;
			PostBuildProcessFile := ProcessFileEdit.Text;
			RecompileFiles;
			if not DebugInfo then
				ClearDebugInfo;
			UpdateDebugSettings;
			Modify;
		end;
	finally
		Free;
	end;
end;

procedure TMainForm.FilePreferences(Sender: TObject);
var
	I: Integer;
begin
	with TPreferencesForm.Create (Self) do try
		StopCompilationBox.Checked := StopOnErrors;
		OpenFolderBox.Checked := OpenFolderMessage;
		DeleteAssemblyFilesBox.Checked := DeleteAssemblyFiles;
		DeleteObjectFilesBox.Checked := DeleteObjectFiles;
{$IFDEF CanSplit}
		SplitFilesCheckBox.Checked := SplitFiles;
{$ENDIF}
		AutoSaveCheckBox.Checked := AutoSave;
		TemplateWizardCheckBox.Checked := TemplateWizard;
		AutoNewsCheckBox.Checked := AutoNews;
		DeleteErrorsCheckBox.Checked := DeleteErrors;
		AllowImplicitCheckBox.Checked := not AssumeUndefined;
		FlatButtonsCheckBox.Checked := MainToolbar.Flat;
		MenuBitmapsCheckBox.Checked := Assigned (MainMenu.Images);
		case TransferTarget of
			ttVTI:
				VTIBox.Checked := True;
			ttCalc:
				RealCalcBox.Checked := True;
			else
				NoneBox.Checked := True;
		end;
		VTIPathEdit.Text := VTIPath;
		case LinkPort of
			CALC_PORT_COM1: PortCOM1Box.Checked := True;
			CALC_PORT_COM2: PortCOM2Box.Checked := True;
			CALC_PORT_COM3: PortCOM3Box.Checked := True;
			CALC_PORT_COM4: PortCOM4Box.Checked := True;
		end;
		case LinkCable of
			CALC_CABLE_BLACKLINK: CableBlackBox.Checked := True;
			CALC_CABLE_GRAPHLINK: CableGrayBox.Checked := True;
		end;
		AsmTabSizeEdit.Text := IntToStr (TabSizeAsm);
		CTabSizeEdit.Text := IntToStr (TabSizeC);
		BackColor := EditorColor;
		ColorCheckBox.Checked := BackColor <> clWindow;
		EditorFont.Assign (MasterUnit.EditorFont);
		OnFlyCheckBox.Checked := EditorOnFly;
		DragDropEditCheckBox.Checked := EditorDragDrop;
		RemoveTrailingSpcCheckBox.Checked := EditorRemoveTrSp;
		AutoBlockCheckBox.Checked := AutoBlocks;
		SyntaxC.Assign (MasterUnit.SyntaxC);
		SyntaxAsmGNU.Assign (MasterUnit.SyntaxAsmGNU);
		if ssA68k in SpecialSupport then
			SyntaxAsm.Assign (MasterUnit.SyntaxAsm);
		if ssQuill in SpecialSupport then
			SyntaxQuill.Assign (MasterUnit.SyntaxQuill);
		if ShowModal = mrOK then begin
			Screen.Cursor := crHourGlass;
			StopOnErrors := StopCompilationBox.Checked;
			OpenFolderMessage := OpenFolderBox.Checked;
			DeleteAssemblyFiles := DeleteAssemblyFilesBox.Checked;
			DeleteObjectFiles := DeleteObjectFilesBox.Checked;
{$IFDEF CanSplit}
			SplitFiles := SplitFilesCheckBox.Checked;
{$ENDIF}
			AutoSave := AutoSaveCheckBox.Checked;
			TemplateWizard := TemplateWizardCheckBox.Checked;
			AutoNews := AutoNewsCheckBox.Checked;
			DeleteErrors := DeleteErrorsCheckBox.Checked;
			AssumeUndefined := not AllowImplicitCheckBox.Checked;
			MainToolbar.Flat := FlatButtonsCheckBox.Checked;
			if MainToolbar.Flat then
				MainToolbar.Height := MainToolbar.ButtonHeight + 1
			else
				MainToolbar.Height := MainToolbar.ButtonHeight + 3;
			if MenuBitmapsCheckBox.Checked then
				MainMenu.Images := ToolbarImages
			else
				MainMenu.Images := nil;
			if VTIBox.Checked then
				TransferTarget := ttVTI
			else if RealCalcBox.Checked then
				TransferTarget := ttCalc
			else
				TransferTarget := ttNone;
			VTIPath := VTIPathEdit.Text;
			if PortCOM1Box.Checked then
				LinkPort := CALC_PORT_COM1
			else if PortCOM2Box.Checked then
				LinkPort := CALC_PORT_COM2
			else if PortCOM3Box.Checked then
				LinkPort := CALC_PORT_COM3
			else if PortCOM4Box.Checked then
				LinkPort := CALC_PORT_COM4;
			if CableBlackBox.Checked then
				LinkCable := CALC_CABLE_BLACKLINK
			else if CableGrayBox.Checked then
				LinkCable := CALC_CABLE_GRAPHLINK;
			try
				TabSizeC := StrToInt (CTabSizeEdit.Text);
			except
				TabSizeC := 2;
			end;
			try
				TabSizeAsm := StrToInt (AsmTabSizeEdit.Text);
			except
				TabSizeAsm := 2;
			end;
			if ColorCheckBox.Checked then
				EditorColor := BackColor
			else
				EditorColor := clWindow;
			MasterUnit.EditorFont.Assign (EditorFont);
			EditorOnFly := OnFlyCheckBox.Checked;
			EditorDragDrop := DragDropEditCheckBox.Checked;
			EditorRemoveTrSp := RemoveTrailingSpcCheckBox.Checked;
			AutoBlocks := AutoBlockCheckBox.Checked;
			with SourceFiles do
				for I := 0 to Count - 1 do
					if Items [I] is TTextSourceFile then
						(Items [I] as TTextSourceFile).UpdateEditor;
			if SyntaxTabClicked then begin
				MasterUnit.SyntaxC.Assign (SyntaxC);
				MasterUnit.SyntaxAsmGNU.Assign (SyntaxAsmGNU);
				MasterUnit.SyntaxAsm.Assign (SyntaxAsm);
				MasterUnit.SyntaxQuill.Assign (SyntaxQuill);
				with SourceFiles do
					for I := 0 to Count - 1 do
						if Items [I] is TSourceTextSourceFile then
							(Items [I] as TSourceTextSourceFile).UpdateSyntax;
			end;
			SavePreferences;
			UpdateDebugSettings;
			Screen.Cursor := crDefault;
		end;
	finally
		Free;
	end;
end;

procedure TMainForm.LoadPreferences;
function LookBackForComponent(Stream: TMemoryStream): Integer;
var
	I: Integer;
	P: PChar;
begin
	Result := 0;
	with Stream do begin
		P := Memory;
		for I := Size - 3 downto 1 do
			if (P [I] = 'T') and (P [I + 1] = 'P') and (P [I + 2] = 'F') then begin
				Result := I;
				Break;
			end;
	end;
end;
var
	I,
	Tmp: Integer;
	L: TStringList;
	Strm: TMemoryStream;
	SyntaxCopy: TSyntaxColoringCopy;
begin
	with TRegistry.Create do try
		if OpenKeyReadOnly (RegKey) then try
			if ValueExists ('Open File') then
				ProjectFile := ReadString ('Open File');
			if ValueExists ('Recent Files') then begin
				L := TStringList.Create;
				try
					L.CommaText := ReadString ('Recent Files');
					for I := L.Count - 1 downto 0 do
						AddToRecent (L.Strings [I]);
				finally
					L.Free;
				end;
			end;
			if ValueExists ('Stop on Errors') then
				StopOnErrors := ReadBool ('Stop on Errors');
			if ValueExists ('Open Folder Message') then
				OpenFolderMessage := ReadBool ('Open Folder Message');
			if ValueExists ('Delete Assembly Files') then
				DeleteAssemblyFiles := ReadBool ('Delete Assembly Files');
			if ValueExists ('Delete Object Files') then
				DeleteObjectFiles := ReadBool ('Delete Object Files');
{$IFDEF CanSplit}
			if ValueExists ('Split Files') then
				SplitFiles := ReadBool ('Split Files');
{$ENDIF}
			if ValueExists ('AutoSave') then
				AutoSave := ReadBool ('AutoSave');
			if ValueExists ('Enable Template Wizard') then
				TemplateWizard := ReadBool ('Enable Template Wizard');
			if ValueExists ('AutoNews') then
				AutoNews := ReadBool ('AutoNews');
			if ValueExists ('Delete Errors') then
				DeleteErrors := ReadBool ('Delete Errors');
			if ValueExists ('Assume Undefined References') then
				AssumeUndefined := ReadBool ('Assume Undefined References');
			if ValueExists ('Flat Buttons') then
				MainToolbar.Flat := ReadBool ('Flat Buttons');
			if MainToolbar.Flat then
				MainToolbar.Height := MainToolbar.ButtonHeight + 1
			else
				MainToolbar.Height := MainToolbar.ButtonHeight + 3;
			if ValueExists ('Menu Bitmaps') then begin
				if ReadBool ('Menu Bitmaps') then
					MainMenu.Images := ToolbarImages
				else
					MainMenu.Images := nil;
			end;
			if ValueExists ('Transfer Target') then
				TransferTarget := TTransferTarget (ReadInteger ('Transfer Target') + 1);
			if ValueExists ('VTI Path') then
				VTIPath := ReadString ('VTI Path');
			if ValueExists ('Link Port') then
				LinkPort := ReadInteger ('Link Port');
			if ValueExists ('Link Cable') then
				LinkCable := ReadInteger ('Link Cable');
			if ValueExists ('ASM Tab Size') then
				TabSizeAsm := ReadInteger ('ASM Tab Size');
			if ValueExists ('C Tab Size') then
				TabSizeC := ReadInteger ('C Tab Size');
			if ValueExists ('Editor Background Color') then
				EditorColor := ReadInteger ('Editor Background Color');
			if ValueExists ('Editor Font') then
				EditorFont.Name := ReadString ('Editor Font');
			if ValueExists ('Editor Font Style Bold') then begin
				EditorFont.Style := [];
				if ReadBool ('Editor Font Style Bold') then
					EditorFont.Style := EditorFont.Style + [fsBold];
				if ReadBool ('Editor Font Style Italic') then
					EditorFont.Style := EditorFont.Style + [fsItalic];
				if ReadBool ('Editor Font Style Underline') then
					EditorFont.Style := EditorFont.Style + [fsUnderline];
				if ReadBool ('Editor Font Style StrikeOut') then
					EditorFont.Style := EditorFont.Style + [fsStrikeOut];
			end;
			if ValueExists ('Editor Font Size') then
				EditorFont.Size := ReadInteger ('Editor Font Size');
			if ValueExists ('Editor Font Color') then
				EditorFont.Color := ReadInteger ('Editor Font Color');
			if ValueExists ('Editor Font Pitch') then
				EditorFont.Pitch := TFontPitch (ReadInteger ('Editor Font Pitch'));
			if ValueExists ('Editor Split On Fly') then
				EditorOnFly := ReadBool ('Editor Split On Fly');
			if ValueExists ('Editor Drag and Drop') then
				EditorDragDrop := ReadBool ('Editor Drag and Drop');
			if ValueExists ('Editor Remove Trailing Spaces') then
				EditorRemoveTrSp := ReadBool ('Editor Remove Trailing Spaces');
			if ValueExists ('AutoBlocks') then
				AutoBlocks := ReadBool ('AutoBlocks');
			if ValueExists ('Tree Width') then
				ProjectTree.Width := ReadInteger ('Tree Width');
			if ValueExists ('Error Window Height') then
				ErrWinPanel.Height := ReadInteger ('Error Window Height');
			if ValueExists ('Error List Message') then
				ErrorList.Columns[0].Width := ReadInteger ('Error List Message');
			if ValueExists ('Error List File') then
				ErrorList.Columns[1].Width := ReadInteger ('Error List File');
			if ValueExists ('Error List Function') then
				ErrorList.Columns[2].Width := ReadInteger ('Error List Function');
			if ValueExists ('Last News Update') then
				LastNewsDate := ReadInteger ('Last News Update');
			if ValueExists ('Proxy Name') then
				ProxyName := ReadString ('Proxy Name');
			if ValueExists ('Proxy Port') then
				ProxyPort := ReadInteger ('Proxy Port');
			Strm := TMemoryStream.Create;
			if ValueExists ('Editor C Syntax Coloring') then try
				SyntaxCopy := TSyntaxColoringCopy.Create (nil);
				try
					SyntaxCopy.Assign (SyntaxC);
					Strm.SetSize (GetDataSize ('Editor C Syntax Coloring'));
					if Strm.Size > 0 then begin
						ReadBinaryData ('Editor C Syntax Coloring', Strm.Memory^, Strm.Size);
						Strm.Position := LookBackForComponent (Strm);
						Strm.ReadComponent (SyntaxCopy);
						SyntaxC.Assign (SyntaxCopy);
					end;
				finally
					SyntaxCopy.Free;
				end;
			except end;
			if ValueExists ('Editor GNU ASM Syntax Coloring') then try
				SyntaxCopy := TSyntaxColoringCopy.Create (nil);
				try
					SyntaxCopy.Assign (SyntaxAsmGNU);
					Strm.SetSize (GetDataSize ('Editor GNU ASM Syntax Coloring'));
					if Strm.Size > 0 then begin
						ReadBinaryData ('Editor GNU ASM Syntax Coloring', Strm.Memory^, Strm.Size);
						Strm.Position := LookBackForComponent (Strm);
						Strm.ReadComponent (SyntaxCopy);
						SyntaxAsmGNU.Assign (SyntaxCopy);
					end;
				finally
					SyntaxCopy.Free;
				end;
			except end;
			if (ssA68k in SpecialSupport) and ValueExists ('Editor ASM Syntax Coloring') then try
				SyntaxCopy := TSyntaxColoringCopy.Create (nil);
				try
					SyntaxCopy.Assign (SyntaxAsm);
					Strm.SetSize (GetDataSize ('Editor ASM Syntax Coloring'));
					if Strm.Size > 0 then begin
						ReadBinaryData ('Editor ASM Syntax Coloring', Strm.Memory^, Strm.Size);
						Strm.Position := LookBackForComponent (Strm);
						Strm.ReadComponent (SyntaxCopy);
						SyntaxAsm.Assign (SyntaxCopy);
					end;
				finally
					SyntaxCopy.Free;
				end;
			except end;
			if (ssQuill in SpecialSupport) and ValueExists ('Editor Quill Syntax Coloring') then try
				SyntaxCopy := TSyntaxColoringCopy.Create (nil);
				try
					SyntaxCopy.Assign (SyntaxQuill);
					Strm.SetSize (GetDataSize ('Editor Quill Syntax Coloring'));
					if Strm.Size > 0 then begin
						ReadBinaryData ('Editor Quill Syntax Coloring', Strm.Memory^, Strm.Size);
						Strm.Position := LookBackForComponent (Strm);
						Strm.ReadComponent (SyntaxCopy);
						SyntaxQuill.Assign (SyntaxCopy);
					end;
				finally
					SyntaxCopy.Free;
				end;
			except end;
			Strm.Free;
			if ValueExists ('Tools Count') then begin
				Tmp := ReadInteger ('Tools Count');
				ToolsList.Clear;
				for I := 1 to Tmp do
					if OpenKeyReadOnly (RegKey + '\Tool ' + IntToStr (I)) then try
						ToolsLine.Visible := True;
						AddTool (ReadString ('Title'), ReadString ('Command Line'), ReadString ('Working Directory'), TWindowState (ReadInteger ('Window State')));
					except end;
			end;
		except end;
	finally
		Free;
		SplitterMoved (Self);
	end;
	with SourceFiles do
		for I := 0 to Count - 1 do begin
			if Items [I] is TTextSourceFile then
				(Items [I] as TTextSourceFile).UpdateEditor;
			if Items [I] is TSourceTextSourceFile then
				(Items [I] as TSourceTextSourceFile).UpdateSyntax;
		end;
	UpdateDebugSettings;
end;

procedure TMainForm.SavePreferences;
var
	I: Integer;
	Strm: TMemoryStream;
	SyntaxCopy: TSyntaxColoringCopy;
begin
	with TRegistry.Create do try
		if OpenKey (RegKey, True) then try
			WriteString ('Open File', ProjectFile);
			WriteString ('Recent Files', RecentFiles.CommaText);
			WriteBool ('Stop on Errors', StopOnErrors);
			WriteBool ('Open Folder Message', OpenFolderMessage);
			WriteBool ('Delete Assembly Files', DeleteAssemblyFiles);
			WriteBool ('Delete Object Files', DeleteObjectFiles);
{$IFDEF CanSplit}
			WriteBool ('Split Files', SplitFiles);
{$ENDIF}
			WriteBool ('AutoSave', AutoSave);
			WriteBool ('Enable Template Wizard', TemplateWizard);
			WriteBool ('AutoNews', AutoNews);
			WriteBool ('Delete Errors', DeleteErrors);
			WriteBool ('Assume Undefined References', AssumeUndefined);
			WriteBool ('Flat Buttons', MainToolbar.Flat);
			WriteBool ('Menu Bitmaps', Assigned (MainMenu.Images));
			WriteInteger ('Transfer Target', Integer (TransferTarget) - 1);
			WriteString ('VTI Path', VTIPath);
			WriteInteger ('Link Port', LinkPort);
			WriteInteger ('Link Cable', LinkCable);
			WriteInteger ('ASM Tab Size', TabSizeAsm);
			WriteInteger ('C Tab Size', TabSizeC);
			WriteInteger ('Editor Background Color', EditorColor);
			WriteString ('Editor Font', EditorFont.Name);
			WriteBool ('Editor Font Style Bold', fsBold in EditorFont.Style);
			WriteBool ('Editor Font Style Italic', fsItalic in EditorFont.Style);
			WriteBool ('Editor Font Style Underline', fsUnderline in EditorFont.Style);
			WriteBool ('Editor Font Style StrikeOut', fsStrikeOut in EditorFont.Style);
			WriteInteger ('Editor Font Size', EditorFont.Size);
			WriteInteger ('Editor Font Color', EditorFont.Color);
			WriteInteger ('Editor Font Pitch', Integer (EditorFont.Pitch));
			WriteBool ('Editor Split On Fly', EditorOnFly);
			WriteBool ('Editor Drag and Drop', EditorDragDrop);
			WriteBool ('Editor Remove Trailing Spaces', EditorRemoveTrSp);
			WriteBool ('AutoBlocks', AutoBlocks);
			WriteInteger ('Tree Width', ProjectTree.Width);
			WriteInteger ('Error Window Height', ErrWinPanel.Height);
			WriteInteger ('Error List Message', ErrorList.Columns[0].Width);
			WriteInteger ('Error List File', ErrorList.Columns[1].Width);
			WriteInteger ('Error List Function', ErrorList.Columns[2].Width);
			WriteInteger ('Last News Update', LastNewsDate);
			WriteString ('Proxy Name', ProxyName);
			WriteInteger ('Proxy Port', ProxyPort);
			Strm := TMemoryStream.Create;
			try
				SyntaxCopy := TSyntaxColoringCopy.Create (nil);
				try
					SyntaxCopy.Assign (SyntaxC);
					Strm.WriteComponent (SyntaxCopy);
					WriteBinaryData ('Editor C Syntax Coloring', Strm.Memory^, Strm.Size);
				finally
					SyntaxCopy.Free;
				end;
				Strm.Clear;
				SyntaxCopy := TSyntaxColoringCopy.Create (nil);
				try
					SyntaxCopy.Assign (SyntaxAsmGNU);
					Strm.WriteComponent (SyntaxCopy);
					WriteBinaryData ('Editor GNU ASM Syntax Coloring', Strm.Memory^, Strm.Size);
				finally
					SyntaxCopy.Free;
				end;
				if ssA68k in SpecialSupport then begin
					Strm.Clear;
					SyntaxCopy := TSyntaxColoringCopy.Create (nil);
					try
						SyntaxCopy.Assign (SyntaxAsm);
						Strm.WriteComponent (SyntaxCopy);
						WriteBinaryData ('Editor ASM Syntax Coloring', Strm.Memory^, Strm.Size);
					finally
						SyntaxCopy.Free;
					end;
				end;
				if ssQuill in SpecialSupport then begin
					Strm.Clear;
					SyntaxCopy := TSyntaxColoringCopy.Create (nil);
					try
						SyntaxCopy.Assign (SyntaxQuill);
						Strm.WriteComponent (SyntaxCopy);
						WriteBinaryData ('Editor Quill Syntax Coloring', Strm.Memory^, Strm.Size);
					finally
						SyntaxCopy.Free;
					end;
				end;
			finally
				Strm.Free;
			end;
			WriteInteger ('Tools Count', ToolsList.Count);
			with ToolsList do
				for I := 0 to Count - 1 do
					with TToolsListItem (Items [I]) do
						if OpenKey (RegKey + '\Tool ' + IntToStr (I + 1), True) then try
							WriteString ('Title', Title);
							WriteString ('Command Line', CommandLine);
							WriteString ('Working Directory', WorkingDir);
							WriteInteger ('Window State', Integer (WindowState));
						except end;
		except end;
	finally
		Free;
	end;
end;

procedure TMainForm.CompileProject;
var
	I: Integer;
	StopIt: Boolean;
begin
	OperationSuccessful := False;
	OperationCancelled := False;
	StopIt := True;
	with SourceFiles do
		for I := 0 to Count - 1 do
			with Items [I] as TSourceFile do
				if Compilable then begin
					StopIt := False;
					Break;
				end;
	if not StopIt then begin
		StopIt := False;
		OperationSuccessful := True;
		CopyHeaders;
		with SourceFiles do
			for I := 0 to Count - 1 do
				if (OperationSuccessful or not StopOnErrors) and not OperationCancelled then
					with Items [I] as TSourceFile do
						if Compilable and Invalidated then begin
							Compile;
							if not OperationSuccessful then
								StopIt := True;
							Application.ProcessMessages;
						end;
		DeleteHeaders;
		if StopIt then
			OperationSuccessful := False;
	end else
		ShowDefaultMessageBox ('There are no files to compile in the current project.', 'Error', mtProgramError);
end;

procedure TMainForm.FileNewHeaderFile(Sender: TObject);
var
	O: THeaderSourceFile;
	N: TTreeNode;
	Wiz: TTemplateWizardForm;
begin
	if not Compiling then begin
		Wiz := TTemplateWizardForm.Create (Self);
		with Wiz do
			if TemplateWizard then begin
				FirstPage := HdrFileStart;
				LastPage := HdrFileEnd;
				if ShowModal <> mrOK then
					Abort;
			end else
				CHdrFileRadioButton.Checked := True;
		O := THeaderSourceFile.Create (SourceFiles);
		with O do begin
			if ProjectFile = '' then
				FileName := 'C:\New File.h'
			else
				FileName := ExtractFilePath (ProjectFile) + 'New File.h';
			OnError := AddError;
			N := ProjectTree.Items.AddChildObject (TopNode.Item [ClassTreeIndex], SourceName, Pointer (O));
			with N do begin
				ImageIndex := ClassImageIndex;
				SelectedIndex := ImageIndex;
			end;
			TreeItem := N;
			ErrorList := Self.ErrorList;
			if Assigned (TextEditor) then
				with TextEditor do begin
					Hide;
					Parent := EditorPanel;
					Align := alClient;
					OnEnter := EditorEnter;
					OnExit := EditorExit;
					OnKeyDown := EditorKeyDown;
					OnChange := EditorChange;
					OnSelectionChange := EditorChange;
					PopupMenu := EditorPopup;
				end;
			with Wiz do begin
				if GNUAsmHdrFileRadioButton.Checked then
					Content := '| Assembly Header File'#13#10'| Created ' + DateToStr (Now) + '; ' + TimeToStr (Now) + #13#10
				else if A68kAsmHdrFileRadioButton.Checked then
					Content := '; Assembly Header File'#13#10'; Created ' + DateToStr (Now) + ', ' + TimeToStr (Now) + #13#10
				else
					Content := '// C Header File'#13#10'// Created ' + DateToStr (Now) + '; ' + TimeToStr (Now) + #13#10;
			end;
			UpdateSyntax;
			if Assigned (TextEditor) then
				TextEditor.ClearUndo;
			Modified := False;
			Invalidate;
		end;
		SelectNode (N);
		N.EditText;
		Wiz.Free;
	end;
end;

procedure TMainForm.FileNewCSourceFile(Sender: TObject);
const
	CodeStr = '// Place your code here.';
var
	O: TCSourceFile;
	N: TTreeNode;
	P: Integer;
	S,
	NewContent: string;
	Wiz: TTemplateWizardForm;
begin
	if not Compiling then begin
		if Assigned (SourceFiles.FindFileOfTypeInProject (TCSourceFile)) then
			Wiz := nil
		else begin
			Wiz := TTemplateWizardForm.Create (Self);
			with Wiz do
				if TemplateWizard then begin
					FirstPage := CFileStart;
					LastPage := CFileEnd;
					if ShowModal <> mrOK then
						Abort;
				end else begin
					TI89CheckBox.Checked := True;
					TI92PlusCheckBox.Checked := True;
					NoStubRadioButton.Checked := True;
					OptimizeROMCallsCheckBox.Checked := False;
					MinAMSCheckBox.Checked := False;
					ReturnDoneRadioButton.Checked := True;
					ReturnToVarCheckBox.Checked := False;
					LCDSaveCheckBox.Checked := True;
					CommentCheckBox.Checked := True;
					CommentEditBox.Text := '';
				end;
		end;
		O := TCSourceFile.Create (SourceFiles);
		with O do begin
			if ProjectFile = '' then
				FileName := 'C:\New File.c'
			else
				FileName := ExtractFilePath (ProjectFile) + 'New File.c';
			OnError := AddError;
			N := ProjectTree.Items.AddChildObject (TopNode.Item [ClassTreeIndex], SourceName, Pointer (O));
			with N do begin
				ImageIndex := ClassImageIndex;
				SelectedIndex := ImageIndex;
			end;
			TreeItem := N;
			ErrorList := Self.ErrorList;
			if Assigned (TextEditor) then
				with TextEditor do begin
					Hide;
					Parent := EditorPanel;
					Align := alClient;
					OnEnter := EditorEnter;
					OnExit := EditorExit;
					OnKeyDown := EditorKeyDown;
					OnChange := EditorChange;
					OnSelectionChange := EditorChange;
					PopupMenu := EditorPopup;
				end;
			NewContent := '// C Source File'#13#10'// Created ' + DateToStr (Now) + '; ' + TimeToStr (Now) + #13#10;
			if Assigned (Wiz) then
				with Wiz do begin
					NewContent := NewContent + #13#10;
					while Pos ('"', CommentEditBox.Text) > 0 do
						CommentEditBox.Text := Copy (CommentEditBox.Text, 1, Pos ('"', CommentEditBox.Text) - 1) + '''' + Copy (CommentEditBox.Text, Pos ('"', CommentEditBox.Text) + 1, Length (CommentEditBox.Text));
					if TI89CheckBox.Checked then
						NewContent := NewContent + '#define USE_TI89              // Compile for TI-89'#13#10;
					if TI92PlusCheckBox.Checked then
						NewContent := NewContent + '#define USE_TI92PLUS          // Compile for TI-92 Plus'#13#10;
					if V200CheckBox.Checked then
						NewContent := NewContent + '#define USE_V200              // Compile for V200'#13#10;
					if ReturnNoneRadioButton.Checked or ReturnValueRadioButton.Checked then begin
						NewContent := NewContent + #13#10'#define RETURN_VALUE';
						if ReturnToVarCheckBox.Checked then
							NewContent := NewContent + ' ' + ReturnVariableEdit.Text + ' // Redirect Return Value'
						else
							NewContent := NewContent + '          // Return Pushed Expression';
						if not EnableErrorReturnCheckBox.Checked then
							NewContent := NewContent + #13#10;
					end;
					if EnableErrorReturnCheckBox.Checked then
						NewContent := NewContent + #13#10'#define ENABLE_ERROR_RETURN   // Enable Returning Errors to AMS'#13#10;
					if DoorsRadioButton.Checked then
						NewContent := NewContent + #13#10'#define USE_KERNEL            // Make Kernel Program'#13#10
					else begin
						NewContent := NewContent + #13#10;
						if not OptimizeROMCallsCheckBox.Checked then
							NewContent := NewContent + '// ';
						NewContent := NewContent + '#define OPTIMIZE_ROM_CALLS';
						if OptimizeROMCallsCheckBox.Checked then
							NewContent := NewContent + '   ';
						NewContent := NewContent + ' // Use ROM Call Optimization'#13#10
							+ #13#10;
						if MinAMSCheckBox.Checked then try
							S := '#define MIN_AMS ' + IntToStr (Round (StrToFloat (MinAMSEdit.Text) * 100));
							NewContent := NewContent + S + StringOfChar (' ', 30 - Length (S)) + '// Compile for AMS ' + MinAMSEdit.Text + ' or higher'#13#10
								+ #13#10;
						except end;
						if not LCDSaveCheckBox.Checked then
							NewContent := NewContent + '// ';
						NewContent := NewContent + '#define SAVE_SCREEN';
						if LCDSaveCheckBox.Checked then
							NewContent := NewContent + '   ';
						NewContent := NewContent + '        // Save/Restore LCD Contents'#13#10;
					end;
					if CommentCheckBox.Checked and DoorsRadioButton.Checked then
						NewContent := NewContent + #13#10'char _comment[] = "' + CommentEditBox.Text + '";'#13#10;
					NewContent := NewContent + #13#10'#include <tigcclib.h>         // Include All Header Files'#13#10
						+ #13#10'// Main Function'#13#10'void _main(void)'#13#10'{'#13#10;
					if ReturnValueRadioButton.Checked then begin
						NewContent := NewContent + #9'// Process arguments here if necessary.'#13#10
							+ #9#13#10
							+ #9'// Clean Up Remaining Arguments'#13#10
							+ #9'while (ESTACK (top_estack) != END_TAG)'#13#10
							+ #9#9'top_estack = next_expression_index (top_estack);'#13#10
							+ #9'top_estack--;'#13#10
							+ #9#13#10;
					end;
					NewContent := NewContent + #9 + CodeStr + #13#10;
					if ReturnValueRadioButton.Checked then begin
						NewContent := NewContent + #9#13#10
							+ #9'// Remember to push an expression to the expression stack.'#13#10;
					end else if ReturnNoneRadioButton.Checked then begin
						NewContent := NewContent + #9#13#10
							+ #9'push_quantum(0xE9);'#13#10;
					end;
					NewContent := NewContent + '}'#13#10;
				end;
			if Assigned (TextEditor) then
				TextEditor.AllowUndo := False;
			Content := NewContent;
			if Assigned (TextEditor) then begin
				TextEditor.AllowUndo := True;
				P := Pos (CodeStr, TextEditor.Text);
				if P > 0 then
					with TextEditor.Selection do begin
						RStart := P;
						RLength := Length (CodeStr);
					end;
			end;
			Modified := False;
			Invalidate;
		end;
		SelectNode (N);
		N.EditText;
		if Assigned (Wiz) then
			Wiz.Free;
	end;
end;

procedure TMainForm.FileNewGNUAssemblerSourceFile(Sender: TObject);
var
	O: TGNUAsmSourceFile;
	N: TTreeNode;
begin
	if not Compiling then begin
		O := TGNUAsmSourceFile.Create (SourceFiles);
		with O do begin
			if ProjectFile = '' then
				FileName := 'C:\New File.s'
			else
				FileName := ExtractFilePath (ProjectFile) + 'New File.s';
			OnError := AddError;
			N := ProjectTree.Items.AddChildObject (TopNode.Item [ClassTreeIndex], SourceName, Pointer (O));
			with N do begin
				ImageIndex := ClassImageIndex;
				SelectedIndex := ImageIndex;
			end;
			TreeItem := N;
			ErrorList := Self.ErrorList;
			if Assigned (TextEditor) then
				with TextEditor do begin
					Hide;
					Parent := EditorPanel;
					Align := alClient;
					OnEnter := EditorEnter;
					OnExit := EditorExit;
					OnKeyDown := EditorKeyDown;
					OnChange := EditorChange;
					OnSelectionChange := EditorChange;
					PopupMenu := EditorPopup;
				end;
			Content := '| Assembly Source File'#13#10'| Created ' + DateToStr (Now) + '; ' + TimeToStr (Now) + #13#10#13#10'.data'#13#10;
			if Assigned (TextEditor) then
				TextEditor.ClearUndo;
			Modified := False;
			Invalidate;
		end;
		SelectNode (N);
		N.EditText;
	end;
end;

procedure TMainForm.FileNewAssemblerSourceFile(Sender: TObject);
var
	O: TAsmSourceFile;
	N: TTreeNode;
begin
	if not Compiling then begin
		O := TAsmSourceFile.Create (SourceFiles);
		with O do begin
			if ProjectFile = '' then
				FileName := 'C:\New File.asm'
			else
				FileName := ExtractFilePath (ProjectFile) + 'New File.asm';
			OnError := AddError;
			N := ProjectTree.Items.AddChildObject (TopNode.Item [ClassTreeIndex], SourceName, Pointer (O));
			with N do begin
				ImageIndex := ClassImageIndex;
				SelectedIndex := ImageIndex;
			end;
			TreeItem := N;
			ErrorList := Self.ErrorList;
			if Assigned (TextEditor) then
				with TextEditor do begin
					Hide;
					Parent := EditorPanel;
					Align := alClient;
					OnEnter := EditorEnter;
					OnExit := EditorExit;
					OnKeyDown := EditorKeyDown;
					OnChange := EditorChange;
					OnSelectionChange := EditorChange;
					PopupMenu := EditorPopup;
				end;
			Content := '; Assembly Source File'#13#10'; Created ' + DateToStr (Now) + ', ' + TimeToStr (Now) + #13#10#13#10#9'section ".data"'#13#10;
			if Assigned (TextEditor) then
				TextEditor.ClearUndo;
			Modified := False;
			Invalidate;
		end;
		SelectNode (N);
		N.EditText;
	end;
end;

procedure TMainForm.FileNewQuillSourceFile(Sender: TObject);
var
	O: TQuillSourceFile;
	N: TTreeNode;
begin
	if not Compiling then begin
		if Assigned (SourceFiles.FindFileOfTypeInProject (TQuillSourceFile)) then
			ShowDefaultMessageBox ('There may be only one Quill source file in each project.', 'Quill Error', mtProgramError)
		else begin
			O := TQuillSourceFile.Create (SourceFiles);
			with O do begin
				if ProjectFile = '' then
					FileName := 'C:\New File.qll'
				else
					FileName := ExtractFilePath (ProjectFile) + 'New File.qll';
				OnError := AddError;
				N := ProjectTree.Items.AddChildObject (TopNode.Item [ClassTreeIndex], SourceName, Pointer (O));
				with N do begin
					ImageIndex := ClassImageIndex;
					SelectedIndex := ImageIndex;
				end;
				TreeItem := N;
				ErrorList := Self.ErrorList;
				if Assigned (TextEditor) then
					with TextEditor do begin
						Hide;
						Parent := EditorPanel;
						Align := alClient;
						OnEnter := EditorEnter;
						OnExit := EditorExit;
						OnKeyDown := EditorKeyDown;
						OnChange := EditorChange;
						OnSelectionChange := EditorChange;
						PopupMenu := EditorPopup;
					end;
				if FileExists (WithBackslash (TIGCCFolder) + QuillIncludeLocation + 'Template.qll') then
					LoadFromFile (WithBackslash (TIGCCFolder) + QuillIncludeLocation + 'Template.qll')
				else if FileExists (WithBackslash (TIGCCFolder) + CIncludeLocation + 'Template.qll') then
					LoadFromFile (WithBackslash (TIGCCFolder) + CIncludeLocation + 'Template.qll')
				else if FileExists (WithBackslash (TIGCCFolder) + GCCLocation + 'Template.qll') then
					LoadFromFile (WithBackslash (TIGCCFolder) + GCCLocation + 'Template.qll');
				Content := '// Quill Source File'#13#10'// Created ' + DateToStr (Now) + '; ' + TimeToStr (Now) + #13#10#13#10 + Content;
				if Assigned (TextEditor) then
					TextEditor.ClearUndo;
				Modified := False;
				Invalidate;
			end;
			SelectNode (N);
			N.EditText;
		end;
	end;
end;

procedure TMainForm.FileNewTextFile(Sender: TObject);
var
	O: TNormalTextSourceFile;
	N: TTreeNode;
begin
	O := TNormalTextSourceFile.Create (SourceFiles);
	with O do begin
		if ProjectFile = '' then
			FileName := 'C:\New File.txt'
		else
			FileName := ExtractFilePath (ProjectFile) + 'New File.txt';
		OnError := AddError;
		N := ProjectTree.Items.AddChildObject (TopNode.Item [ClassTreeIndex], SourceName, Pointer (O));
		with N do begin
			ImageIndex := ClassImageIndex;
			SelectedIndex := ImageIndex;
		end;
		TreeItem := N;
		ErrorList := Self.ErrorList;
		if Assigned (TextEditor) then
			with TextEditor do begin
				Hide;
				Parent := EditorPanel;
				Align := alClient;
				OnEnter := EditorEnter;
				OnExit := EditorExit;
				OnKeyDown := EditorKeyDown;
				OnChange := EditorChange;
				OnSelectionChange := EditorChange;
				PopupMenu := EditorPopup;
			end;
		if Assigned (TextEditor) then
			TextEditor.ClearUndo;
		Modified := False;
	end;
	SelectNode (N);
	N.EditText;
end;

procedure TMainForm.TreeItemSaveAs(Sender: TObject);
begin
	if Assigned (ProjectTree.Selected) and Assigned (ProjectTree.Selected.Data) then begin
		TSourceFile(ProjectTree.Selected.Data).SaveAs;
		Modify;
		UpdateStatusBar;
	end;
end;

procedure TMainForm.BeginCompilation;
var
	I: Integer;
begin
	ClearErrors;
	with SourceFiles do
		for I := 0 to Count - 1 do
			with Items [I] as TSourceFile do
				if not InProject then begin
					RecompileFiles;
					Break;
				end;
	OperationCancelled := False;
	OperationSuccessful := False;
end;

procedure TMainForm.EndCompilation;
begin
	CompStop;
	Application.Restore;
	UpdateErrorWindow;
	ShowErrors;
	if ErrorList.Items.Count > 0 then begin
		ErrorList.Selected := ErrorList.Items [0];
		ErrorListClick (Self);
	end;
end;

procedure TMainForm.HelpAbout(Sender: TObject);
begin
	with TAboutForm.Create (Self) do try
		ShowModal;
	finally
		Free;
	end;
end;

procedure TMainForm.DisplayHint(Sender: TObject);
begin
	with StatusBar.Panels do begin
		BeginUpdate;
		with Items [0] do begin
			if Application.Hint = '' then
				Width := 0
			else
				Width := 1000000;
			Text := Application.Hint;
		end;
		EndUpdate;
	end;
end;

procedure TMainForm.ShowHideErrors(Sender: TObject);
begin
	with ActionProjectShowErrors do begin
		if Checked then
			HideErrors
		else
			ShowErrors;
	end;
end;

procedure TMainForm.UpdateEditButtons;
var
	TextSel: Boolean;
	Editor: TMemoComponent;
begin
	Editor := CurrentEditor;
	if Assigned (Editor) then begin
		TextSel := (Editor.SelLength > 0) and (ActiveControl = Editor);
		ActionEditDelete.Enabled := TextSel;
		ActionEditCut.Enabled := TextSel;
		ActionEditCopy.Enabled := TextSel;
		ActionEditUndo.Enabled := (ActiveControl = Editor) and Editor.CanUndo;
		ActionEditRedo.Enabled := (ActiveControl = Editor) and Editor.CanRedo;
	end;
end;

procedure TMainForm.RecompileFiles;
var
	I: Integer;
begin
	with SourceFiles do
		for I := 0 to Count - 1 do
			with Items [I] as TSourceFile do
				if Items [I] is THeaderSourceFile then
					Invalidated := False
				else if Compilable then
					Invalidate;
end;

procedure TMainForm.FindString(Sender: TObject; AllFiles: Boolean);
var
	P: Integer;
	S,
	T: string;
	Valid: Boolean;
	FPos: Integer;
	Editor: TMemoComponent;
	NewSelection: TTreeNode;
	FirstFile: Boolean;
begin
	NewSelection := ProjectTree.Selected;
	if not Assigned (NewSelection) then
		NewSelection := TopNode;
	Valid := False;
	FirstFile := True;
	repeat
		if Assigned (NewSelection.Data) then
			if TSourceFile (NewSelection.Data) is TTextSourceFile then begin
				Editor := TTextSourceFile(NewSelection.Data).TextEditor;
				if Assigned (Editor) then begin
					with Sender as TFindDialog do begin
						if (frFindNext in Options) and FirstFile then
							P := Editor.Selection.REnd
						else
							if frDown in Options then
								P := 0
							else
								P := Length (Editor.Text);
						repeat
							if frDown in Options then
								T := Copy (Editor.Text, P + 1, Length (Editor.Text))
							else
								T := Copy (Editor.Text, 1, P - 1);
							if frMatchCase in Options then
								S := FindText
							else begin
								S := UpperCase (FindText);
								T := UpperCase (T);
							end;
							if frDown in Options then
								FPos := Pos (S, T)
							else
								FPos := LastPos (S, T);
							if FPos > 0 then begin
								Valid := True;
								if frWholeWord in Options then begin
									if ((FPos > 1) and (T <> '') and (T [FPos - 1] in ['A'..'Z', 'a'..'z', '0'..'9', '_', '$'])) then
										Valid := False;
									if ((FPos + Length (S) < Length (T)) and (T <> '') and (T [FPos + Length (S)] in ['A'..'Z', 'a'..'z', '0'..'9', '_', '$'])) then
										Valid := False;
								end;
								if not (frDown in Options) then
									P := 0;
								if not Valid then
									Inc (P, FPos);
							end;
						until Valid or (FPos <= 0);
						if Valid then begin
							SelectNode (NewSelection);
							with Editor.Selection do begin
								DoChanging;
								RStart := P + FPos;
								RLength := Length (S);
								DoChange;
								ScrollInView (2);
							end;
							SetFocus;
						end;
					end;
				end;
			end;
		if AllFiles and (not Valid) then begin
			if frDown in (Sender as TFindDialog).Options then begin
				NewSelection := NewSelection.GetNext;
				if not Assigned (NewSelection) then
					NewSelection := TopNode;
			end else begin
				NewSelection := NewSelection.GetPrev;
				if not Assigned (NewSelection) then begin
					NewSelection := TopNode;
					while NewSelection.Count > 0 do
						NewSelection := NewSelection.Item [NewSelection.Count - 1];
				end;
			end;
			FirstFile := False;
		end;
	until (not AllFiles) or Valid or (NewSelection = ProjectTree.Selected);
	if not Valid then
		Abort;
end;

procedure TMainForm.ReplaceDlgReplace(Sender: TObject);
var
	Editor: TMemoComponent;
begin
	Editor := CurrentEditor;
	if Assigned (Editor) then
		with Sender as TReplaceDialog do
			if (frReplace in Options) or (frReplaceAll in Options) then
				repeat
					if UpperCase (Editor.Selection.Text) = UpperCase (FindText) then
						Editor.Selection.Text := ReplaceText;
					Options := Options + [frFindNext];
					FindString (Sender, False);
				until not (frReplaceAll in Options);
end;

procedure TMainForm.FindText(Sender: TObject);
begin
	try
		if Assigned (CurrentEditor) then
			if CurrentEditor.Selection.RLength > 0 then
				FindDlg.FindText := CurrentEditor.Selection.Text;
		FindDlg.Execute;
	except end;
end;

procedure TMainForm.ReplaceText(Sender: TObject);
begin
	try
		if Assigned (CurrentEditor) then
			if CurrentEditor.Selection.RLength > 0 then begin
				ReplaceDlg.FindText := CurrentEditor.Selection.Text;
				ReplaceDlg.ReplaceText := ReplaceDlg.FindText;
			end;
		ReplaceDlg.Execute;
	except end;
end;

procedure TMainForm.FindAndOpenFile(Sender: TObject);
var
	I: Integer;
	S: string;
	QuotesInLine: Boolean;
	SourceFile: TSourceFile;
	Editor: TMemoComponent;
begin
	Editor := CurrentEditor;
	if Assigned (Editor) then begin
		QuotesInLine := Pos ('"', Editor.Lines [Editor.Selection.StartRowCol.Row - 1]) > 0;
		S := '';
		for I := Editor.Selection.RStart - 1 downto 1 do begin
			if (not QuotesInLine) and (Editor.Text [I] = ' ') then
				Break;
			if Editor.Text [I] in [' ', 'A'..'Z', 'a'..'z', '0'..'9', '_', '-', '.', '\', ':'] then
				S := Editor.Text [I] + S
			else
				Break;
		end;
		for I := Editor.Selection.RStart to Length (Editor.Text) do begin
			if (not QuotesInLine) and (Editor.Text [I] = ' ') then
				Break;
			if Editor.Text [I] in [' ', 'A'..'Z', 'a'..'z', '0'..'9', '_', '-', '.', '\', ':'] then
				S := S + Editor.Text [I]
			else
				Break;
		end;
		S := Trim (S);
		if Length (S) > 0 then begin
			SourceFile := SourceFiles.FindFileNameOnly (S);
			if Assigned (SourceFile) then
				SourceFile.Edit
			else begin
				if FileExists (ExpandFileName (S)) then
					AddSourceFile (ExpandFileName (S), True)
				else if FileExists (WithBackslash (TIGCCFolder) + CIncludeLocation + S) then
					AddSourceFile (WithBackslash (TIGCCFolder) + CIncludeLocation + S, True)
				else if FileExists (WithBackslash (TIGCCFolder) + ASMIncludeLocation + S) then
					AddSourceFile (WithBackslash (TIGCCFolder) + ASMIncludeLocation + S, True)
				else
					ShowDefaultMessageBox ('File ''' + S + ''' not found.', 'Search Failed', mtProgramError);
			end;
		end;
	end;
end;

procedure TMainForm.FindDlgFind(Sender: TObject);
begin
	try
		FindString (Sender, True);
	except
		ShowDefaultMessageBox ('Text ''' + (Sender as TFindDialog).FindText + ''' not found.', 'Search Failed', mtProgramError);
	end;
end;

procedure TMainForm.ActionsExecute(Action: TBasicAction;
	var Handled: Boolean);
begin
	Application.ProcessMessages;
	Handled := False;
end;

procedure TMainForm.ProjectTreeEnter(Sender: TObject);
begin
	ActionEditDelete.Enabled := Assigned (ProjectTree.Selected) and Assigned (ProjectTree.Selected.Data);
end;

procedure TMainForm.ProjectTreeExit(Sender: TObject);
begin
	ActionEditDelete.Enabled := False;
end;

procedure TMainForm.ProjectTreeChanging(Sender: TObject; Node: TTreeNode;
	var AllowChange: Boolean);
begin
	if not NoHideEditor then begin
		if Assigned (EditorToHide) then
			EditorToHide.Hide;
		if (not Closing) and Assigned (PreviousNode) and Assigned (PreviousNode.Data) then
			EditorToHide := TSourceFile(PreviousNode.Data).Editor
		else
			EditorToHide := NoEditor;
	end;
end;

procedure TMainForm.EditorChange(Sender: TObject);
begin
	if ActiveControl = Sender then
		UpdateEditButtons;
	UpdateStatusBar;
end;

procedure TMainForm.FilePrint(Sender: TObject);
var
	Cp: Integer;
begin
	if Assigned (ProjectTree.Selected) and Assigned (ProjectTree.Selected.Data) and (Printer.Printers.Count > 0) then try
		PrintDlg.PrintRange := prAllPages;
		PrintDlg.MaxPage := TSourceFile(ProjectTree.Selected.Data).CountPages;
		PrintDlg.ToPage := PrintDlg.MaxPage;
		if Assigned (CurrentEditor) then begin
			if CurrentEditor.Selection.RLength > 0 then
				PrintDlg.Options := PrintDlg.Options + [poSelection]
			else
				PrintDlg.Options := PrintDlg.Options - [poSelection];
		end;
		if Assigned (Sender) then begin
			if not PrintDlg.Execute then
				Abort;
			Cp := PrintDlg.Copies;
			if Cp < 1 then
				Cp := 1;
		end else
			Cp := 1;
		TSourceFile(ProjectTree.Selected.Data).Print (Cp, PrintDlg.PrintRange, PrintDlg.FromPage, PrintDlg.ToPage);
	except
		Abort;
	end;
end;

procedure TMainForm.FilePrintQuickly(Sender: TObject);
begin
	FilePrint (nil);
end;

procedure TMainForm.TreeItemRename(Sender: TObject);
begin
	if Assigned (ProjectTree.Selected) then
		ProjectTree.Selected.EditText;
end;

procedure TMainForm.HelpContents(Sender: TObject);
begin
	try
		DocFile.DisplayContentsTab;
	except
		ShowDefaultMessageBox ('Error opening documentation.', 'Error', mtProgramError);
	end;
end;

procedure TMainForm.HelpIndex(Sender: TObject);
begin
	try
		DocFile.DisplayIndexTab;
	except
		ShowDefaultMessageBox ('Error opening documentation.', 'Error', mtProgramError);
	end;
end;

procedure TMainForm.HelpSearch(Sender: TObject);
begin
	try
		DocFile.DisplaySearchTab;
	except
		ShowDefaultMessageBox ('Error opening documentation.', 'Error', mtProgramError);
	end;
end;

procedure TMainForm.SplitterMoved(Sender: TObject);
begin
	StatusBar.Panels[1].Width := ProjectTree.Width;
	Update;
end;

procedure TMainForm.UpdateStatusBar;
var
	S: string;
	I: Integer;
	Total: Integer;
	Cell: TTextCell;
begin
	with StatusBar.Panels do begin
		Total := 0;
		with TopNode do
			for I := 0 to Count - 1 do
				Inc (Total, Item[I].Count);
		S := IntToStr (Total) + ' File';
		if Total <> 1 then
			S := S + 's';
		S := S + ' Total';
		Total := -1;
		if Assigned (ProjectTree.Selected) then
			with ProjectTree.Selected do
				if Parent = TopNode then
					Total := Count
				else
					if Assigned (Parent) then
						Total := Parent.Count;
		if Total >= 0 then
			S := S + ', ' + IntToStr (Total) + ' in Category';
		if Items[1].Text <> S then
			Items[1].Text := S;
		if Assigned (CurrentEditor) then begin
			with CurrentEditor do begin
				if Enabled then begin
					if Selection.RLength > 0 then begin
						I := Selection.RLength + Selection.StartRowCol.Row - Selection.EndRowCol.Row;
						if Selection.EndRowCol.Col > LineLength [Selection.EndRowCol.Row] then
							Dec (I);
						S := IntToStr (I);
						if Items[3].Text <> S then
							Items[3].Text := S;
						if Items[4].Text <> '' then
							Items[4].Text := '';
						if Items[3].Width <> 60 then
							Items[3].Width := 60;
						if Items[4].Width <> 0 then
							Items[4].Width := 0;
					end else begin
						Cell := Selection.StartRowCol;
						S := IntToStr (Cell.Row);
						if Items[3].Text <> S then
							Items[3].Text := S;
						S := IntToStr (Cell.Col);
						if Items[4].Text <> S then
							Items[4].Text := S;
						if Items[3].Width <> 30 then
							Items[3].Width := 30;
						if Items[4].Width <> 30 then
							Items[4].Width := 30;
					end;
					I := TextLength - LineCount + 1;
					S := IntToStr (I) + ' Character';
					if I <> 1 then
						S := S + 's';
					if Items[11].Text <> S then
						Items[11].Text := S;
					if Items[10].Width <> 1 then
						Items[10].Width := 1;
					if Items[11].Width <> 93 then
						Items[11].Width := 93;
					if Items[12].Width <> 1 then
						Items[12].Width := 1;
				end;
			end;
		end else begin
			if Items[3].Text <> '' then
				Items[3].Text := '';
			if Items[4].Text <> '' then
				Items[4].Text := '';
			if Items[11].Text <> '' then
				Items[11].Text := '';
			if Items[3].Width <> 0 then
				Items[3].Width := 0;
			if Items[4].Width <> 0 then
				Items[4].Width := 0;
			if Items[10].Width <> 0 then
				Items[10].Width := 0;
			if Items[11].Width <> 0 then
				Items[11].Width := 0;
			if Items[12].Width <> 0 then
				Items[12].Width := 0;
		end;
		S := '';
		if Assigned (ProjectTree.Selected) then begin
			if Assigned (ProjectTree.Selected.Data) then begin
				with TSourceFile (ProjectTree.Selected.Data) do
					if (ProjectFile = '') and (ExtractFilePath (FileName) = 'C:\') then
						S := ExtractFileName (FileName)
					else
						S := FileName;
			end else
				if ProjectTree.Selected = TopNode then
					S := ProjectFile;
		end;
		if Items[13].Text <> S then
			Items[13].Text := S;
	end;
	Update;
end;

procedure TMainForm.ProjectTreeMouseDown(Sender: TObject;
	Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
	if Button = mbRight then
		SelectNode (ProjectTree.GetNodeAt (X, Y));
end;

procedure TMainForm.SetModified(const Value: Boolean);
begin
	FModified := Value;
	UpdateStatusBar;
	if Value then
		Invalidated := True;
end;

procedure TMainForm.ToolBarManagerBandMove(Sender: TObject;
	Control: TControl; var ARect: TRect);
begin
	Update;
end;

procedure TMainForm.ProjectTreeDragOver(Sender, Source: TObject; X,
	Y: Integer; State: TDragState; var Accept: Boolean);
var
	S,
	D: TTreeNode;
begin
	Accept := False;
	with ProjectTree do begin
		S := Selected;
		if Assigned (S) and Assigned (S.Data) then begin
			D := GetNodeAt (X, Y);
			if Assigned (D) and (D <> TopNode) then begin
				if Assigned (D.Data) then
					Accept := (S <> D) and (S.Parent = D.Parent)
				else
					Accept := S.Parent <> D;
			end;
		end;
	end;
end;

procedure TMainForm.ProjectTreeDragDrop(Sender, Source: TObject; X,
	Y: Integer);
var
	S,
	D: TTreeNode;
	FN: string;
	F: TSourceFile;
begin
	with ProjectTree do begin
		S := Selected;
		D := GetNodeAt (X, Y);
		if Assigned (D) and (D <> TopNode) then begin
			if Assigned (D.Data) then begin
				if (S <> D) and (S.Parent = D.Parent) then begin
					if D.Index > S.Index then begin
						if D.GetNextSibling <> nil then
							S.MoveTo (D.GetNextSibling, naInsert)
						else
							S.MoveTo (D, naAdd);
					end else
						S.MoveTo (D, naInsert);
					Modify;
				end;
			end else begin
				if S.Parent <> D then begin
					with TSourceFile (S.Data) do begin
						WarnIfModified;
						FN := FileName;
					end;
					S.Delete;
					F := AddSourceFile (FN, False, TSourceFile.GetAppropriateClassFromTreeIndex (D.Index));
					if Assigned (F) and Assigned (F.TreeItem) then
						SelectNode (F.TreeItem);
					Modify;
				end;
			end;
		end;
		if Assigned (CurrentEditor) then
			CurrentEditor.Refresh;
	end;
	SortFiles;
end;

procedure TMainForm.ErrorListClick(Sender: TObject);
begin
	if Enabled and Assigned (ErrorList.Selected) then
		TFoundError(ErrorList.Selected.Data).GoToPosition;
end;

function TMainForm.GetCurrentEditor: TMemoComponent;
begin
	if Assigned (ProjectTree.Selected) and Assigned (ProjectTree.Selected.Data) and (TSourceFile(ProjectTree.Selected.Data) is TTextSourceFile) then
		Result := TTextSourceFile(ProjectTree.Selected.Data).TextEditor
	else
		Result := nil;
end;

procedure TMainForm.DeleteError(Sender: TObject);
var
	I: Integer;
begin
	if DeleteErrors then begin
		with ErrorList.Items do
			for I := Count - 1 downto 0 do
				if Assigned (Item[I].Data) then
					with TFoundError (Item[I].Data) do
						if Range = Sender then
							Item[I].Delete;
		UpdateErrorWindow;
	end;
end;

procedure TMainForm.UpdateFuncs;
begin
	if Assigned (ProjectTree.Selected) and Assigned (ProjectTree.Selected.Data) and (TSourceFile(ProjectTree.Selected.Data) is TSourceTextSourceFile) then
		with TSourceTextSourceFile (ProjectTree.Selected.Data) do
			Funcs := GetFunctions
	else
		SetLength (Funcs, 0);
end;

procedure TMainForm.FunctionPopupPopup(Sender: TObject);
var
	I,
	P: Integer;
	M: TMenuItem;
begin
	with (Sender as TPopupMenu).Items do begin
		for I := Count - 1 downto 0 do
			Remove (Items [I]);
		UpdateFuncs;
		for I := Low (Funcs) to High (Funcs) do begin
			M := TMenuItem.Create (Self);
			with M do begin
				Tag := I;
				Caption := Funcs[I].Name;
				OnClick := FindFunctionFromPopup;
			end;
			P := Pos ('main', Funcs[I].Name);
			if (P <> 0) and (P = Length (Funcs[I].Name) - Length ('main') + 1) then
				Insert (0, M)
			else
				Add (M);
		end;
		if Count <= 0 then
			Add (NoFunctionsItem);
	end;
end;

procedure TMainForm.FindFunctions(Sender: TObject);
var
	I: Integer;
	Editor: TMemoComponent;
begin
	UpdateFuncs;
	with TFunctionsForm.Create (Self) do try
		Funcs := @Self.Funcs;
		with FuncList.Items do begin
			BeginUpdate;
			Clear;
			for I := Low (Self.Funcs) to High (Self.Funcs) do
				AddObject (Self.Funcs[I].Name, TObject (I));
			EndUpdate;
		end;
		FuncListClick (FuncList);
		case ShowModal of
			mrYes: begin
				Editor := CurrentEditor;
				if Assigned (Editor) then begin
					Editor.Selection.NoSelAtPos (Editor.CellToCharIdx (TextCell (Self.Funcs[Integer(FuncList.Items.Objects[FuncList.ItemIndex])].PrototypeLine, 1)));
					Editor.Selection.ScrollInView (5);
				end;
			end;
			mrNo: begin
				Editor := CurrentEditor;
				if Assigned (Editor) then begin
					Editor.Selection.NoSelAtPos (Editor.CellToCharIdx (TextCell (Self.Funcs[Integer(FuncList.Items.Objects[FuncList.ItemIndex])].ImplementationLine, 1)));
					Editor.Selection.ScrollInView (5);
				end;
			end;
		end;
		with FuncList.Items do begin
			BeginUpdate;
			for I := Count - 1 downto 0 do begin
				Objects [I] := nil;
				Delete (I);
			end;
			EndUpdate;
		end;
	finally
		Free;
	end;
end;

procedure TMainForm.FindFunctionFromPopup(Sender: TObject);
var
	L: Integer;
	Editor: TMemoComponent;
begin
	if Sender is TMenuItem then
		with Sender as TMenuItem do begin
			if Funcs[Tag].ImplementationLine > 0 then
				L := Funcs[Tag].ImplementationLine
			else
				L := Funcs[Tag].PrototypeLine;
			if L > 0 then begin
				Editor := CurrentEditor;
				if Assigned (Editor) then begin
					Editor.Selection.NoSelAtPos (Editor.CellToCharIdx (TextCell (L, 1)));
					Editor.Selection.ScrollInView (5);
					if Editor.Visible and Editor.Enabled then
						ActiveControl := Editor;
				end;
			end;
		end;
end;

procedure TMainForm.IncreaseIndent(Sender: TObject);
var
	Editor: TMemoComponent;
begin
	Editor := CurrentEditor;
	if Assigned (Editor) then
		Editor.ChangeIndent (1);
end;

procedure TMainForm.DecreaseIndent(Sender: TObject);
var
	Editor: TMemoComponent;
begin
	Editor := CurrentEditor;
	if Assigned (Editor) then
		Editor.ChangeIndent (-1);
end;

procedure TMainForm.SortFiles;
var
	CurFileIndex: Integer;
procedure DoSortFiles(Node: TTreeNode);
var
	I: Integer;
begin
	with Node do begin
		if Assigned (Data) and (TObject (Data) is TSourceFile) then begin
			with TSourceFile (Data) do
				if Index > CurFileIndex then
					Index := CurFileIndex;
			Inc (CurFileIndex);
		end;
		for I := 0 to Count - 1 do
			DoSortFiles (Item [I]);
	end;
end;
var
	I: Integer;
begin
	CurFileIndex := 0;
	{	This is supposed to be: DoSortFiles (TopNode);
		However, header files are dependent on the other
		files and therefore have to be put after all the
		others. }
	with TopNode do begin
		for I := 0 to Count - 1 do
			if I <> THeaderSourceFile.GetClassTreeIndex then
				DoSortFiles (Item [I]);
		if Count > THeaderSourceFile.GetClassTreeIndex then
			DoSortFiles (Item [THeaderSourceFile.GetClassTreeIndex]);
	end;
end;

procedure TMainForm.AppCompSetMessage(const Msg: string);
begin
	with StatusBar do
		Panels.Items[6].Text := Msg + '...';
	if not Compiling then begin
		Compiling := True;
		CompUpdate;
		UpdateDebugSettings;
		with StatusBar.Panels do begin
			Items[5].Width := 5;
			Items[6].Width := 180;
			Items[7].Width := 100;
			Items[8].Width := 100;
			Items[9].Width := 1000000;
		end;
	end;
end;

procedure TMainForm.AppCompStartFile;
var
	I: Integer;
begin
	Application.Hint := '';
	CompFinishAndStop := False;
	CompStopNow := False;
	CompFileStartTime := Now;
	CompLastTime := 0;
	if not Compiling then begin
		CompStartTime := CompFileStartTime;
		ToolBarNewButton.Enabled := False;
		MenuFileNew.Enabled := False;
		ActionFileOpen.Enabled := False;
		ActionFileExit.Enabled := False;
		ActionProjectAddFiles.Enabled := False;
		ActionProjectCompile.Visible := False;
		ActionProjectMake.Visible := False;
		ActionProjectBuild.Visible := False;
		ActionProjectStopCompilation.Enabled := True;
		ActionProjectForceQuitCompiler.Enabled := True;
		ActionProjectStopCompilation.Visible := True;
		ActionProjectForceQuitCompiler.Visible := True;
		with RecentFiles do
			for I := 0 to Count - 1 do
				with TRecentFileMenuItem (Objects [I]) do begin
					FileMenuItem.Enabled := False;
					PopupMenuItem.Enabled := False;
				end;
	end;
end;

procedure TMainForm.AppCompStop;
var
	I: Integer;
begin
	if Compiling then begin
		Compiling := False;
		ActionProjectStopCompilation.Visible := False;
		ActionProjectForceQuitCompiler.Visible := False;
		ToolBarNewButton.Enabled := True;
		MenuFileNew.Enabled := True;
		ActionFileOpen.Enabled := True;
		ActionFileExit.Enabled := True;
		ActionProjectAddFiles.Enabled := True;
		ActionProjectCompile.Visible := True;
		ActionProjectMake.Visible := True;
		ActionProjectBuild.Visible := True;
		with RecentFiles do
			for I := 0 to Count - 1 do
				with TRecentFileMenuItem (Objects [I]) do begin
					FileMenuItem.Enabled := True;
					PopupMenuItem.Enabled := True;
				end;
		UpdateDebugSettings;
		with StatusBar.Panels do begin
			Items[5].Width := 0;
			Items[6].Width := 0;
			Items[7].Width := 0;
			Items[8].Width := 0;
			Items[9].Width := 0;
		end;
	end;
end;

procedure TMainForm.AppCompUpdate;
const
	SecondsPerDay = 24 * 60 * 60;
function CustomTimeToStr(ConvTime: TDateTime): string;
var
	Seconds: Integer;
	MinStr,
	SecStr: string;
begin
	Seconds := Trunc (ConvTime * SecondsPerDay);
	MinStr := IntToStr (Seconds div 60);
	SecStr := IntToStr (Seconds mod 60);
	while Length (SecStr) < 2 do
		SecStr := '0' + SecStr;
	Result := MinStr + ':' + SecStr;
end;
var
	CurTime: TDateTime;
begin
	CurTime := Now;
	if Trunc (CompLastTime * SecondsPerDay) <> Trunc (CurTime * SecondsPerDay) then begin
		CompLastTime := CurTime;
		with StatusBar, Panels do begin
			Items[7].Text := 'File Time: ' + CustomTimeToStr (CurTime - CompFileStartTime);
			Items[8].Text := 'Total Time: ' + CustomTimeToStr (CurTime - CompStartTime);
			Update;
		end;
	end;
end;

procedure TMainForm.DisplayFolderMessage;
var
	S: string;
begin
	if OperationSuccessful and (not OperationCancelled) and OpenFolderMessage then begin
		if ProgSize <= 0 then
			S := ''
		else
			S := '  (' + IntToStr (ProgSize) + ' Bytes)';
		if ShowDefaultMessageBox ('The project has been compiled successfully.  Do you want to open the project folder?', 'Compilation Successful' + S, mtQuestion) = idYes then
			ShellExecute (0, nil, PChar (ExtractFilePath (ProjectFile)), nil, nil, sw_ShowNormal);
	end;
end;

procedure TMainForm.ProjectStopCompilation(Sender: TObject);
begin
	CompFinishAndStop := True;
	ActionProjectStopCompilation.Enabled := False;
end;

procedure TMainForm.ProjectForceQuitCompiler(Sender: TObject);
begin
	CompStopNow := True;
end;

procedure TMainForm.WMDropFiles(var Msg: TMessage);
var
	DropHandle: THandle;
	I,
	FileCount: Integer;
	CurFile: array [0..512] of Char;
begin
	DropHandle := Msg.WParam;
	FileCount := DragQueryFile (DropHandle, High (Cardinal), nil, 0);
	for I := 0 to FileCount - 1 do begin
		DragQueryFile (DropHandle, I, CurFile, SizeOf (CurFile) - 1);
		if LowerCase (ExtractFileExt (AnsiString (CurFile))) = LowerCase (ProjectFileExt) then
			FileOpen (AnsiString (CurFile))
		else
			AddSourceFile (AnsiString (CurFile), True);
	end;
	DragFinish (DropHandle);
end;

procedure TMainForm.ClearDebugInfo;
begin
	SetLength (CurrentSymbols, 0);
	if Assigned (CurrentStrings) then begin
		CurrentStrings.Free;
		CurrentStrings := nil;
	end;
end;

procedure TMainForm.HelpNews(Sender: TObject);
begin
	with TNewsForm.Create (Self) do try
		Execute;
	finally
		Free;
	end;
end;

function TMainForm.GetVTIWindow: HWnd;
begin
	CurVTIType := cvNone;
	Result := FindWindow ('TEmuWnd', 'Virtual TI-89');
	if Result = 0 then begin
		Result := FindWindow ('TEmuWnd', 'Virtual TI-92+');
		if Result <> 0 then
			CurVTIType := cvTI92Plus;
	end else
		CurVTIType := cvTI89;
	if Result = 0 then begin
		if Length (VTIPath) > 0 then begin
			with TVTIStartForm.Create (Self) do try
				if ShowModal = mrOK then begin
					Result := VTIWindow;
					CurVTIType := VTIType;
				end else
					Abort;
			finally
				Free;
			end;
		end else begin
			ShowDefaultMessageBox ('Virtual TI is not running.', 'Error', mtProgramError);
			Abort;
		end;
	end;
end;

procedure TMainForm.SendFiles(FNList: array of string);
var
	Win: HWnd;
procedure SendKey(Key: Byte);
begin
	PostMessage (Win, WM_KEYDOWN, Key, 0);
	PostMessage (Win, WM_KEYUP, Key, 0);
end;
var
	I: Integer;
	EditWin,
	ButtonWin: HWnd;
	StartTime: Cardinal;
	FileString: string;
	Name: array [0..32] of Char;
	Link: TLinkHandle;
	CalcType: TCalcType;
	Size: Word;
	Total: Cardinal;
	Progress: DWord;
	ProgressForm: TSendProgressForm;
begin
	OperationSuccessful := False;
	OperationCancelled := False;
	if Length (FNList) > 0 then begin
		if TransferTarget = ttVTI then begin
			Win := GetVTIWindow;
			GetWindowThreadProcessID (Win, @ProcID);
			SendKey (VK_SCROLL);
			SendKey (VK_ESCAPE);
			if CurVTIType = cvTI89 then
				SendKey (VK_HOME);
			SendKey (VK_F10);
			StartTime := GetTickCount;
			SendWin := 0;
			repeat
				EnumWindows (@EnumWindowsFunc, 0);
			until (SendWin <> 0) or (GetTickCount - StartTime >= 10000);
			if SendWin = 0 then begin
				ShowDefaultMessageBox ('Error displaying send dialog.', 'Error', mtProgramError);
				Abort;
			end else begin
				SetForegroundWindow (SendWin);
				repeat
					EditWin := GetWindow (SendWin, GW_CHILD);
					GetClassName (EditWin, Name, 32);
					while (EditWin <> 0) and (UpperCase (AnsiString (Name)) <> 'EDIT') do begin
						EditWin := GetWindow (EditWin, GW_HWNDNEXT);
						if EditWin <> 0 then
							GetClassName (EditWin, Name, 32);
					end;
					if EditWin <> 0 then begin
						StartTime := GetTickCount;
						while (SendMessage (EditWin, WM_GETTEXTLENGTH, 0, 0) <= 0) and (GetTickCount - StartTime < 5000) do;
						FileString := '';
						for I := Low (FNList) to High (FNList) do begin
							if CurVTIType = cvTI92Plus then
								FNList [I] := StringReplace (FNList [I], '.89', '.9x', []);
							if not FileExists (FNList [I]) then begin
								ShowDefaultMessageBox ('The file "' + FNList [I] + '" could not be found.', 'Error', mtProgramError);
								Abort;
							end;
							Insert ('"' + FNList [I] + '" ', FileString, Length (FileString) + 1);
						end;
						Delete (FileString, Length (FileString), 1);
						SendMessage (EditWin, WM_SETTEXT, 0, Integer (PChar (FileString)));
					end;
					ButtonWin := GetWindow (SendWin, GW_CHILD);
					GetClassName (ButtonWin, Name, 32);
					while (ButtonWin <> 0) and ((UpperCase (AnsiString (Name)) <> 'BUTTON') or ((GetWindowLong (ButtonWin, GWL_STYLE) and BS_DEFPUSHBUTTON) = 0) or ((GetWindowLong (ButtonWin, GWL_STYLE) and BS_CHECKBOX) <> 0)) do begin
						ButtonWin := GetWindow (ButtonWin, GW_HWNDNEXT);
						if ButtonWin <> 0 then
							GetClassName (ButtonWin, Name, 32);
					end;
				until SendMessage (EditWin, WM_GETTEXTLENGTH, 0, 0) >= Length (FNList [Low (FNList)]);
				if ButtonWin <> 0 then begin
					SendMessage (ButtonWin, WM_LBUTTONDOWN, 0, 0);
					SendMessage (ButtonWin, WM_LBUTTONUP, 0, 0);
				end;
			end;
			ShowWindow (Win, SW_SHOWNORMAL);
			SetForegroundWindow (Win);
		end else if TransferTarget = ttCalc then begin
			if InitializeLink then begin
				Link := CreateConnection (LinkPort, LinkCable);
				if Assigned (Link) then try
					if OpenConnection (Link) then begin
						CalcType := GetCalcType (Link);
						Total := 0;
						for I := Low (FNList) to High (FNList) do begin
							if CalcType = CALC_TYPE_TI92PLUS then
								FNList [I] := StringReplace (FNList [I], '.89', '.9x', []);
							if not FileExists (FNList [I]) then begin
								ShowDefaultMessageBox ('The file "' + FNList [I] + '" could not be found.', 'Error', mtProgramError);
								Abort;
							end;
							if not CheckFileFormat (Link, PChar (FNList [I]), nil, nil, @Size) then begin
								ShowDefaultMessageBox ('Error sending file.', 'Error', mtProgramError);
								Abort;
							end;
							Inc (Total, Size);
						end;
						Enabled := False;
						try
							ProgressForm := TSendProgressForm.Create (Self);
							with ProgressForm do try
								ProgressBar.Max := Total;
								Show;
								Update;
								Progress := 0;
								for I := Low (FNList) to High (FNList) do begin
									FileNameLabel.Caption := ExtractFileName (FNList [I]);
									if not SendFile (Link, nil, nil, PChar (FNList [I]), @Progress, ProgressProg, ProgressForm) then begin
										if Cancelled then
											OperationCancelled := True
										else
											ShowDefaultMessageBox ('Error sending file. Please check whether your calculator is on the home screen.', 'Error', mtProgramError);
										Abort;
									end;
								end;
							finally
								CloseNow := True;
								Free;
							end;
						finally
							Enabled := True;
						end;
					end else begin
						ShowDefaultMessageBox ('Error linking to calculator.', 'Error', mtProgramError);
						Abort;
					end;
				finally
					CloseConnection (Link);
				end else begin
					ShowDefaultMessageBox ('Error opening link port.', 'Error', mtProgramError);
					Abort;
				end;
			end else begin
				ShowDefaultMessageBox ('Could not find the required link library.', 'Error', mtProgramError);
				Abort;
			end;
		end;
		OperationSuccessful := True;
	end;
end;

procedure TMainForm.ExecuteCommandLine(const Line: string);
var
	Win: HWnd;
procedure SendKey(Key: Byte);
begin
	SendMessage (Win, WM_KEYDOWN, Key, 0);
	SendMessage (Win, WM_KEYUP, Key, 0);
	Sleep (20);
end;
var
	I: Integer;
	Link: TLinkHandle;
begin
	if TransferTarget = ttVTI then begin
		Win := GetVTIWindow;
		SendKey (VK_SCROLL);
		SendKey (VK_ESCAPE);
		SendKey (VK_ESCAPE);
		if CurVTIType = cvTI89 then
			SendKey (VK_HOME);
		SendKey (VK_DELETE);
		SendKey (VK_DELETE);
		for I := 1 to Length (Line) do
			if Line [I] in ['A'..'Z', 'a'..'z', '0'..'9'] then
				SendKey (Byte (UpCase (Line [I])))
			else if Line [I] = '(' then
				SendKey ($DB)
			else if Line [I] = ')' then
				SendKey ($DD)
			else if Line [I] = ',' then
				SendKey ($BC)
			else if Line [I] = '.' then
				SendKey (VK_DECIMAL)
			else if Line [I] = '+' then
				SendKey (VK_ADD)
			else if Line [I] = '-' then
				SendKey (VK_SUBTRACT)
			else if Line [I] = '*' then
				SendKey (VK_MULTIPLY)
			else if Line [I] = '/' then
				SendKey (VK_DIVIDE)
			else if Line [I] = '\' then begin
				SendKey (VK_MENU);
				SendKey (Byte ('2'));
			end;
		SendKey (VK_RETURN);
	end else if TransferTarget = ttCalc then begin
		if InitializeLink then begin
			Link := CreateConnection (LinkPort, LinkCable);
			if Assigned (Link) then try
				if OpenConnection (Link) then
					ExecuteHomeLine (Link, PChar (Line))
				else begin
					ShowDefaultMessageBox ('Error linking to calculator.', 'Error', mtProgramError);
					Abort;
				end;
			finally
				CloseConnection (Link);
			end else begin
				ShowDefaultMessageBox ('Error opening link port.', 'Error', mtProgramError);
				Abort;
			end;
		end else begin
			ShowDefaultMessageBox ('Could not find the required link library.', 'Error', mtProgramError);
			Abort;
		end;
	end;
end;

procedure TMainForm.DebugRun(Sender: TObject);
var
	Files: array of string;
begin
	OperationSuccessful := True;
	OperationCancelled := False;
	if Invalidated then
		MakeFileWrapped;
	if OperationSuccessful and (not OperationCancelled) and (FileExists (ChangeFileExt (ProjectFile, '.89z')) or FileExists (ChangeFileExt (ProjectFile, '.9xz'))) then begin
		if Runnable then begin
			SetLength (Files, 1);
			Files [Low (Files)] := ChangeFileExt (ProjectFile, '.89z');
			if Pack and (ssPack in SpecialSupport) then begin
				SetLength (Files, Length (Files) + 1);
				Files [High (Files)] := ChangeFileExt (ProjectFile, '.89y');
			end;
			SendFiles (Files);
			if OperationSuccessful then
				ExecuteCommandLine (TopNode.Text + '(' + CommandLine + ')');
		end else
			DisplayFolderMessage;
	end;
end;

procedure TMainForm.DebugPause(Sender: TObject);
var
	Win: HWnd;
procedure SendKey(Key: Byte);
begin
	PostMessage (Win, WM_KEYDOWN, Key, 0);
	PostMessage (Win, WM_KEYUP, Key, 0);
end;
begin
	Win := GetVTIWindow;
	SendKey (VK_F11);
	ShowWindow (Win, SW_SHOWNORMAL);
	SetForegroundWindow (Win);
end;

procedure TMainForm.DebugReset(Sender: TObject);
var
	Win: HWnd;
procedure SendKey(Key: Byte);
begin
	PostMessage (Win, WM_KEYDOWN, Key, 0);
	PostMessage (Win, WM_KEYUP, Key, 0);
end;
begin
	Win := GetVTIWindow;
	SendKey (VK_APPS);
	SendKey (Byte ('T'));
	ShowWindow (Win, SW_SHOWNORMAL);
	SetForegroundWindow (Win);
end;

function TMainForm.GetInvalidated: Boolean;
var
	I: Integer;
begin
	Result := FInvalidated;
	if not Result then
		with SourceFiles do
			for I := 0 to Count - 1 do
				with Items [I] as TSourceFile do
					if (Compilable or (Items [I] is THeaderSourceFile)) and Invalidated then begin
						Result := True;
						Break;
					end;
end;

procedure TMainForm.UpdateDebugSettings;
var
	CanRun: Boolean;
begin
	CanRun := Runnable;
	ActionDebugRun.Enabled := not Compiling;
	ActionDebugPause.Enabled := (not Compiling) and (TransferTarget = ttVTI);
	ActionDebugReset.Enabled := (not Compiling) and (TransferTarget = ttVTI);
	MainMenuDebug.Visible := CanRun;
	if not CanRun then
		ToolBarDebugLine.Parent := nil;
	ToolBarRunButton.Visible := CanRun;
	ToolBarPauseButton.Visible := CanRun;
	ToolBarDebugLine.Visible := CanRun;
	if CanRun then begin
		ToolBarDebugLine.Parent := MainToolBar;
		ToolBarDebugLine.Left := ToolBarPauseButton.Left + ToolBarPauseButton.Width;
	end;
end;

procedure TMainForm.FormKeyDown(Sender: TObject; var Key: Word;
	Shift: TShiftState);
var
	NewSelection: TTreeNode;
begin
	if (Key = vk_F9) and (Shift = [ssShift, ssCtrl, ssAlt]) then begin
		if TransferTarget = ttVTI then
			TransferTarget := ttCalc
		else
			TransferTarget := ttVTI;
		SavePreferences;
		UpdateDebugSettings;
	end else if (Key = vk_Tab) and (Shift = [ssCtrl]) then begin
		NewSelection := ProjectTree.Selected;
		if Assigned (NewSelection) then begin
			repeat
				NewSelection := NewSelection.GetNext;
				if not Assigned (NewSelection) then
					NewSelection := TopNode;
			until (NewSelection.IsVisible and Assigned (NewSelection.Data)) or (NewSelection = ProjectTree.Selected);
			if Assigned (NewSelection.Data) then
				SelectNode (NewSelection);
			if Assigned (CurrentEditor) and CurrentEditor.Enabled then try
				CurrentEditor.SetFocus;
			except end;
		end;
	end;
end;

procedure TMainForm.SelectNode(Node: TTreeNode);
var
	Allow: Boolean;
begin
	if PreviousNode <> Node then begin
		Allow := True;
		ProjectTreeChanging (ProjectTree, Node, Allow);
		if Allow then begin
			NoHideEditor := True;
			ProjectTree.Selected := Node;
			NoHideEditor := False;
		end;
	end;
end;

procedure TMainForm.ChangeNotificationTick(Sender: TObject);
var
	I: Integer;
begin
	if not InChangeNotification then begin
		InChangeNotification := True;
		with SourceFiles do
			for I := 0 to Count - 1 do
				with TSourceFile (Items [I]) do
					TestChange;
		InChangeNotification := False;
	end;
end;

procedure TMainForm.ResetProjectSettings;
begin
	ProjectTarget := ptExecutable;
	Pack := False;
	PackVar := '';
	GCCSwitches := '-Os -Wall -W -Wwrite-strings';
	AsSwitches := '';
	AsmSwitches := '-g -t';
	LinkSwitches := '';
	LdSwitches := '';
	DebugInfo := False;
	StdLib := True;
	CommandLine := '';
	PostBuildProcessFile := '';
end;

procedure TMainForm.AddToRecent(const FileName: string);
var
	I: Integer;
	O: TRecentFileMenuItem;
begin
	with RecentFiles do begin
		for I := 0 to Count - 1 do
			if (I >= MaxRecentFiles - 1) or (UpperCase (Strings [I]) = UpperCase (FileName)) then begin
				if I = 0 then
					Exit
				else begin
					Objects[I].Free;
					Delete (I);
					Break;
				end;
			end;
		RecentFilesLine.Visible := True;
		O := TRecentFileMenuItem.Create;
		with O do begin
			FileMenuItem := TMenuItem.Create (Self);
			with FileMenuItem do begin
				Caption := WithoutExt (ExtractFileName (FileName));
				Hint := FileName;
				OnClick := RecentFileClick;
			end;
			MainMenuFile.Insert (RecentFilesLine.MenuIndex + 1, FileMenuItem);
			PopupMenuItem := TMenuItem.Create (Self);
			with PopupMenuItem do begin
				Caption := FileName;
				Hint := FileName;
				OnClick := RecentFileClick;
			end;
			RecentFilesPopup.Items.Insert (0, PopupMenuItem);
		end;
		InsertObject (0, FileName, O);
	end;
	UpdateRecent;
end;

procedure TMainForm.UpdateRecent;
begin
	RecentFilesLine.Visible := RecentFiles.Count > 0;
	NoFilesItem.Visible := RecentFiles.Count <= 0;
end;

procedure TMainForm.RecentFileClick(Sender: TObject);
var
	I: Integer;
	FileName: string;
begin
	FileName := (Sender as TMenuItem).Hint;
	if FileExists (FileName) then
		FileOpen (FileName)
	else begin
		with RecentFiles do
			for I := 0 to Count - 1 do
				if UpperCase (Strings [I]) = UpperCase (FileName) then begin
					Objects[I].Free;
					Delete (I);
					Break;
				end;
		UpdateRecent;
		ShowDefaultMessageBox ('File ''' + WithoutExt (ExtractFileName (FileName)) + ''' not found.', 'Error', mtProgramError);
	end;
end;

procedure TMainForm.ToolsConfigure(Sender: TObject);
var
	I: Integer;
begin
	with TToolsForm.Create (Self) do try
		with Self.ToolsList do
			for I := 0 to Count - 1 do
				with ToolsList.Items.Add, TToolsListItem (Items [I]) do begin
					Caption := Title;
					SubItems.Add (CommandLine);
					SubItems.Add (WorkingDir);
					SubItems.Add (WindowStateToString (WindowState));
				end;
		if ShowModal = mrOK then begin
			Self.ToolsList.Clear;
			with ToolsList.Items do begin
				ToolsLine.Visible := Count > 0;
				for I := 0 to Count - 1 do
					with Item [I] do
						AddTool (Caption, SubItems [0], SubItems [1], StringToWindowState (SubItems [2]));
			end;
			SavePreferences;
		end;
	finally
		Free;
	end;
end;

procedure TMainForm.ToolClick(Sender: TObject);
var
	WorkDir: PChar;
	StartupInfo: TStartupInfo;
	ProcessInfo: TProcessInformation;
begin
	with TToolsListItem ((Sender as TMenuItem).Tag) do begin
		FillChar (StartupInfo, SizeOf (StartupInfo), 0);
		StartupInfo.cb := SizeOf (StartupInfo);
		if Length (WorkingDir) > 0 then
			WorkDir := PChar (WorkingDir)
		else
			WorkDir := nil;
		StartupInfo.dwFlags := StartF_UseShowWindow;
		case WindowState of
			wsMaximized:
				StartupInfo.wShowWindow := SW_SHOWMAXIMIZED;
			wsMinimized:
				StartupInfo.wShowWindow := SW_SHOWMINIMIZED;
			else
				StartupInfo.dwFlags := 0;
		end;
		if CreateProcess (nil, PChar (CommandLine), nil, nil, False, CREATE_NEW_PROCESS_GROUP or DETACHED_PROCESS, nil, WorkDir, StartupInfo, ProcessInfo) then begin
			CloseHandle (ProcessInfo.hProcess);
			CloseHandle (ProcessInfo.hThread);
		end else
			ShowDefaultMessageBox ('An error occurred while trying to start the application.', 'Error', mtProgramError);
	end;
end;

procedure TMainForm.AddTool(const Title, CommandLine, WorkingDir: string; WindowState: TWindowState);
var
	O: TToolsListItem;
begin
	O := TToolsListItem (Self.ToolsList.Add);
	O.Title := Title;
	O.CommandLine := CommandLine;
	O.WorkingDir := WorkingDir;
	O.WindowState := WindowState;
	O.MenuItem := TMenuItem.Create (Self);
	with O.MenuItem do begin
		Tag := Integer (O);
		Caption := Title;
		Hint := CommandLine;
		OnClick := ToolClick;
	end;
	MainMenuTools.Insert (MainMenuTools.Count, O.MenuItem);
end;

procedure TMainForm.ProjectTreeStartDrag(Sender: TObject;
	var DragObject: TDragObject);
begin
	DragObject := TNoImageDragObject.Create (Sender as TControl);
end;

procedure TMainForm.UpdateProgramOutput;
begin
	ActionProjectShowProgramOutput.Enabled := (MainConsole.LastOutSize > 2) or (MainConsole.LastErrSize > 2);
end;

procedure TMainForm.ShowProgramOutput(Sender: TObject);
begin
	with TProgramOutputForm.Create (Self) do try
		OutputMemo.Text := MainConsole.LastOutText;
		ErrorMemo.Text := MainConsole.LastErrText;
		ShowModal;
	finally
		Free;
	end;
end;

end.
