unit ExtractIconUnit;

interface

uses
	Windows, SysUtils, ActiveX, ComObj, ShlObj;

type
	TExtractIcon = class(TComObject, IExtractIcon)
	protected
    function GetIconLocation(uFlags: UINT; szIconFile: PAnsiChar; cchMax: UINT;
			out piIndex: Integer; out pwFlags: UINT): HResult; virtual; stdcall;
		function Extract(pszFile: PAnsiChar; nIconIndex: UINT;
			out phiconLarge, phiconSmall: HICON; nIconSize: UINT): HResult; virtual; stdcall;
	end;

const
	Class_ExtractIcon: TGUID = '{595D2824-10B5-11D5-A253-00900001489D}';

implementation

uses
	ComServ;

{ TExtractIcon }

function TExtractIcon.Extract(pszFile: PAnsiChar; nIconIndex: UINT;
	out phiconLarge, phiconSmall: HICON; nIconSize: UINT): HResult;
begin
	Result := S_False;
end;

function TExtractIcon.GetIconLocation(uFlags: UINT; szIconFile: PAnsiChar;
	cchMax: UINT; out piIndex: Integer; out pwFlags: UINT): HResult;
begin
	StrPLCopy (szIconFile, 'SHELL32.DLL', cchMax);
	if (uFlags and GIL_OPENICON) <> 0 then
		piIndex := 4
	else
		piIndex := 3;
	pwFlags := GIL_PERINSTANCE;
	Result := S_OK;
end;

initialization
	TComObjectFactory.Create(ComServer, TExtractIcon, Class_ExtractIcon,
		'ExtractIcon', '', ciInternal, tmApartment);
end.
