library FolderLink;

uses
	SysUtils,
  Classes,
  ComServ,
  LinkUnit in 'LinkUnit.pas',
  ShellFolderUnit in 'ShellFolderUnit.pas',
  ShellViewUnit in 'ShellViewUnit.pas',
  EnumIDListUnit in 'EnumIDListUnit.pas',
  SubFolderUnit in 'SubFolderUnit.pas',
  ExtractIconUnit in 'ExtractIconUnit.pas',
	SubViewUnit in 'SubViewUnit.pas',
	DropTargetUnit in 'DropTargetUnit.pas';

{$R *.res}

exports
	DllGetClassObject,
	DllCanUnloadNow,
	DllRegisterServer,
	DllUnregisterServer,

	CreateConnection,
	OpenConnection,
	CloseConnection,
	CalcReady,
	SendAck,
	SendWait,
	SendByte,
	SendWord,
	SendLongWord,
	SendString,
	SendKey(Handle: TLinkHandle; Key: Word),
	SendKeys,
	SendVar,
	SendFile,
	CheckFileFormat,
	ExecuteHomeLine,
	WaitForAck,
	CalcWaiting,
	ReceiveByte,
	ReceiveWord,
	ReceiveLongWord,
	GetCalcType,
	GetFolderList,
	GetVarList,
	TryOpenConnection,
	GetUIString;
end.
