program IDE;

uses
	Forms,
  Controls,
  VersionUnit in 'VersionUnit.pas',
  SourceFileUnit in 'SourceFileUnit.pas',
  MasterUnit in 'MasterUnit.pas',
  ParsingUnit in 'ParsingUnit.pas',
  ObjectFileUnit in 'ObjectFileUnit.pas',
  ProcessUnit in 'ProcessUnit.pas',
  LinkImportUnit in '..\Shell Folder\LinkImportUnit.pas',
  ToolsListUnit in 'ToolsListUnit.pas',
  MainUnit in 'MainUnit.pas' {MainForm},
  ProjectOptionsUnit in 'ProjectOptionsUnit.pas' {ProjectOptionsForm},
  PreferencesUnit in 'PreferencesUnit.pas' {PreferencesForm},
  AboutUnit in 'AboutUnit.pas' {AboutForm},
  TemplateWizardUnit in 'TemplateWizardUnit.pas' {TemplateWizardForm},
  StyleSelectionUnit in 'StyleSelectionUnit.pas' {StyleSelectionForm},
  ColorsUnit in 'ColorsUnit.pas' {MultipleColorsForm},
  CustomStyleUnit in 'CustomStyleUnit.pas' {CustomStyleForm},
  WordListUnit in 'WordListUnit.pas' {WordListForm},
  StartupScreenUnit in 'StartupScreenUnit.pas' {StartupScreenForm},
  SourceFileWinUnit in 'SourceFileWinUnit.pas' {SourceFileForm},
  FunctionsWinUnit in 'FunctionsWinUnit.pas' {FunctionsForm},
  OpenFileStatusUnit in 'OpenFileStatusUnit.pas' {OpenFileStatusForm},
  NewsUnit in 'NewsUnit.pas' {NewsForm},
  SendProgressUnit in 'SendProgressUnit.pas' {SendProgressForm},
  ToolsUnit in 'ToolsUnit.pas' {ToolsForm},
  ToolPropertiesUnit in 'ToolPropertiesUnit.pas' {ToolPropertiesForm},
  ProgramOutputUnit in 'ProgramOutputUnit.pas' {ProgramOutputForm},
  VTIStartUnit in 'VTIStartUnit.pas' {VTIStartForm};

{$R *.RES}

var
	DontRun: Boolean = False;

begin
	Application.Initialize;
	Application.Title := 'TIGCC IDE';
	Screen.Cursor := crAppStart;
	StartupScreenForm := TStartupScreenForm.Create (Application);
	StartupScreenForm.Show;
	StartupScreenForm.Update;
	StartupScreenForm.DisplayText := 'Creating Main Window...';
	Application.CreateForm(TMainForm, MainForm);
  StartupScreenForm.Free;
	StartupScreenForm := nil;
	Screen.Cursor := crDefault;
	Application.Run;
end.
