unit SendProgressUnit;

interface

uses
	LinkImportUnit,
	Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
	StdCtrls, ComCtrls;

type
	TSendProgressForm = class(TForm)
		ProgressBar: TProgressBar;
		FileNameLabel: TLabel;
		CancelButton: TButton;
		procedure CancelButtonClick(Sender: TObject);
		procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
	private
	public
		Cancelled: Boolean;
		CloseNow: Boolean;
	end;

function ProgressProg(ID: Pointer; Progress: PDWord): TCalcBool; stdcall;

implementation

{$R *.DFM}

function ProgressProg(ID: Pointer; Progress: PDWord): TCalcBool; stdcall;
begin
	with TSendProgressForm (ID) do begin
		ProgressBar.Position := Progress^;
		Result := not Cancelled;
	end;
	Application.ProcessMessages;
end;

procedure TSendProgressForm.CancelButtonClick(Sender: TObject);
begin
	Cancelled := True;
end;

procedure TSendProgressForm.FormCloseQuery(Sender: TObject;
	var CanClose: Boolean);
begin
	CanClose := CloseNow;
	if not CanClose then
		Cancelled := True;
end;

end.
